<? // vim:encoding=utf8:
require_once "lib/page.inc.php";
require_once "lib/auth.inc.php";
require_once "lib/aktuality.inc.php";
require_once "lib/obrazek.inc.php";
require_once "lib/editor.inc.php";

/* init stranky */
$auth = new Auth;
$lvl = $auth->check_login();
$page = new Page($id ? "Úprava aktuality" : "Přidání nové aktuality", $auth->get_username(), $lvl);
$page->generate_header();

if ($lvl < AUTH_EDITOR) {
	if ($lvl == 0)
		$auth->print_must_login();
	else
		$auth->print_access_denied();
	$page->generate_footer();
	exit;
}

/* init aktualit */
$aktuality = new Aktuality(A_ALL);


/*****************************************************************************
 * Formular
 */
if (isset($_GET['id'])) {
	$def = $aktuality->get_by_id($_GET['id']);
	list($ld, $lt) = explode(" ", $def["date_start"], 2);
	list($def['date_start_y'], $def['date_start_m'], $def['date_start_d']) = explode("-", $ld, 3);
	list($def['date_start_H'], $def['date_start_M'], $def['date_start_S']) = explode(":", $lt, 3);
	list($ld, $lt) = explode(" ", $def["date_end"], 2);
	list($def['date_end_y'], $def['date_end_m'], $def['date_end_d']) = explode("-", $ld, 3);
	list($def['date_end_H'], $def['date_end_M'], $def['date_end_S']) = explode(":", $lt, 3);
	if ($def['image'] != "") {
		$def['image_src'] = 'actual';
		$def['image_actual'] = $def['image'];
	} else {
		$def['image_src'] = 'none';
	}
} else {
	$def = array(
		'date_start_y' => date('Y'),
		'date_end_y' => date('Y'),
		'date_start_S' => '00',
		'date_end_S' => '00',
		'image_src' => 'none'
	);
}

$ed = new Editor($_POST, $def, $auth->get_userid(), 52);
$ed->set_group(2);
$ed->add_hidden('id');
$ed->add_label('Povinné položky:');
$ed->add_combo('type', 'Typ aktuality', array('Akce'=>0, 'Novinka'=>1), true);
$ed->add_datetime_entry('date_start', 'Datum a čas začátku', true, true);
$ed->add_datetime_entry('date_end', 'Datum a čas konce', true, true);
$ed->add_text_entry('fdate', 'Formátované datum', true);
$ed->add_text_entry('title', 'Nadpis (místo)', true);
$ed->add_text_area('text', 'Text', true);
$ed->set_group(1);
$ed->add_label('Nepovinné položky:');
$ed->add_text_entry('sraz', 'Sraz', false);
$ed->add_text_entry('ssebou', 'S sebou', false);
$ed->add_text_entry('cena', 'Cena', false);
$ed->add_text_entry('ps', 'ps', false);
$ed->add_label('Obrázek:');
$o = new Obrazek(0, OBR_AKTUALITA);
$ed->add_image_store('image', 'Obrázek', $o->get_dir());
unset($o);

/*****************************************************************************
 * Zpracovani
 */
//$ed->dump_data();
if ($ed->is_completed()) {
	$d = $ed->get_values();
	// int mktime ( int hour, int minute, int second, int month, int day, int year, int is_dst);
	$start = date("Y-m-d H:i:s", mktime($d['date_start_H'], $d['date_start_M'], $d['date_start_S'],
						$d['date_start_m'], $d['date_start_d'], $d['date_start_y']));
	$end = date("Y-m-d H:i:s", mktime($d['date_end_H'], $d['date_end_M'], $d['date_end_S'],
						$d['date_end_m'], $d['date_end_d'], $d['date_end_y']));

	//echo "<pre>start: ".$start."\n"."end:   ".$end."</pre>";

	if (!$id) { /* potrebujeme zjistit id aktuality */
		$new = $aktuality->add($d['id'], $d['type'], $start, $end,
				$d['fdate'], $d['title'], $d['text'],
				$d['sraz'], $d['ssebou'], $d['cena'], $d['ps'],
				"");
	} else {
		$new = $id;
	}
	
	/* obrazek */
	if ($d['image_src'] == 'none') {
		$img_file = '';

	} else if ($d['image_src'] == 'url' && $d['image_url'] != '') {
		$img = new Obrazek($new, OBR_AKTUALITA);
		if (strstr($d['image_url'], 'http://') != $d['image_url']
				&& strstr($d['image_url'], 'https://') != $d['image_url']
				&& strstr($d['image_url'], 'ftps://') != $d['image_url']
				&& strstr($d['image_url'], 'ftp://') != $d['image_url'])
		{
			$d['image_url'] = 'http://'.$d['image_url'];
		}
		$img->download($d['image_url']);
		$img_file = $img->gen_name();

	} else if ($d['image_src'] == 'upload' && is_uploaded_file($d['image_upload'])) {
		/*
		$img = new Obrazek($new, OBR_AKTUALITA);
		$img->store($d['image_upload'], $uploadimage_name);
		$img_file = $img->gen_name();
		*/

	} else /* ($d['image_src'] == 'actual') */ {
		$img_file = $d['image_actual'];
	}

	$new = $aktuality->add($new, $d['type'], $start, $end,
			$d['fdate'], $d['title'], $d['text'],
			$d['sraz'], $d['ssebou'], $d['cena'], $d['ps'],
			$img_file);
		

	echo "<div class=success><h2>Aktualita byla ".($id ? "upravena":"vytvořena")."</h2>\n"
		."<p><a href='aktuality-list.php'>seznam aktualit</a></p>\n"
		."<p><a href='aktuality-edit.php?id=".$new."'>znovu upravit tuto aktualitu</a></p>\n"
		."</div>\n";

	echo "<div class=preview>\n";
	echo "<dl class=\"aktuality\">\n";
	echo $aktuality->to_string($aktuality->get_by_id($new));
	echo "</dl>\n";
	echo "<div class=ender></div>\n";
	echo "</div>\n";
} else {
	$ed->render_form();

	?>
	<h4>Poznámky:</h4>
	<ul>
	<li>Položky jako je &bdquo;Sraz&rdquo; lze přidat tagem
	&bdquo;<code>&lt;p class="info"&gt;&lt;b&gt;Nadpis:&lt;/b&gt; text&lt;/p&gt;</code>&rdquo;
	v poli text.
	<li>Pokud je aktualita &bdquo;novinkou&rdquo;, tak datum začátku a
	konce jsou shodné a je to datum vložení novinky.
	</ul>
	<?
}

$page->generate_footer();
?>
