<? // vim:encoding=utf8:
require_once "lib/auth.inc.php";
require_once "lib/aktuality.inc.php";
require_once "lib/page.inc.php";
require_once "lib/database.inc.php";
require_once "lib/htmlmail.inc.php";
require_once "config.php";

$db = new Database();

function check_string($name, $enhanced = false) {
	$old = array('á', 'Á', 'č', 'Č', 'ď', 'Ď', 'é', 'É', 'ě', 'Ě', 'í', 'Í', 'ň',
	'Ň', 'ó', 'Ó', 'ř', 'Ř', 'š', 'Š', 'ť', 'Ť', 'ů', 'Ú', 'ú', 'Ů', 'ý',
	'Ý', 'ž', 'Ž', '.');
	$new = array('a', 'A', 'c', 'C', 'd', 'D', 'e', 'E', 'e', 'E', 'i', 'I', 'n',
	'N', 'o', 'O', 'r', 'R', 's', 'S', 't', 'T', 'u', 'U', 'u', 'U', 'y',
	'Y', 'z', 'Z', '.');
	$n = preg_replace($enhanced ? '/[^a-zA-Z0-9áÁčČďĎéÉěĚíÍňŇóÓřŘšŠťŤůÚúŮýÝžŽ.:\/\\;_() \-"\'<>]/'
			: '/[^a-zA-Z0-9áÁčČďĎéÉěĚíÍňŇóÓřŘšŠťŤůÚúŮýÝžŽ._() \-]/', '', $name);
	for ($i = 0; $old[$i] != '.'; $i++) {
		$n = str_replace($old[$i], $new[$i], $n);
	}
	return $n;
}

function create_mail ($aktual, $subj, $data, $query, $preview, $storno) {
	global $db;
	$body = "<dl>\n";
	$body .= $aktual->to_string($data);
	$body .= "</dl>\n";

	/* vyber useru a jejich mailu z databaze */
	$res = $db->query($query);
	$addr_array = array();
	$addr_str = "";
	$addr_i = 0;
	while ($user = $db->fetch($res)) {
		if (preg_match('/^[_a-zA-Z0-9.-]*\@[_a-zA-Z0-9-]*\.[_a-zA-Z0-9-]*$/',
			$user['mail']) > 0)
		{
			$addr_array[$addr_i++] = "\"".check_string(($user['prezdivka'] == ''
				? $user['jmeno']." ".$user['prijmeni'].""
				: $user['prezdivka']
				))
				."\" <".$user['mail'].">";
			$addr_str .= ($addr_str == '' ? '':', ')."\""
				.check_string(($user['prezdivka'] == ''
				? $user['jmeno']." ".$user['prijmeni'].""
				: $user['prezdivka']
				))
				."\" <".$user['mail'].">";
		} else {
			echo "<div>Neplatný mail: <tt>\""
				.htmlspecialchars($user['mail'])."\"</tt></div>\n";
		}
	}
	echo "<div class=mail>\n";
	echo "<div><b>Příjemci:</b> ".($addr_str == '' ? '<i>nikdo - mail nebude odeslan</i>'
					: "<tt>".htmlspecialchars($addr_str)."</tt>")
					."</div>\n"; 
	echo "<div><b>Předmět:</b> <tt>".check_string($subj, true)."</tt></div>\n";
	if ($preview && $storno)
		echo "<div class=storno><a href='".$_SERVER['PHP_SELF']."?storno=".$data['id']."'>"
				."Zrušit posílání této aktuality</a></div>\n";
	echo "<div class=mailbody>\n".$body."\n</div>\n";
	echo "</div>\n";
	
	/* odeslani mailu */
	if (!$preview && $addr_str != '') {
		htmlmail($addr_array, $subj, $body);
	}

}

/****************************************************************************/

$auth = new Auth;
$lvl = $auth->check_login();
$host_allow = ALLOWED_MAILER_HOST;
$username = $_SERVER["REMOTE_ADDR"] == $host_allow
			? "(atlantis-planner)"
			: $auth->get_username();
	
$page = new Page("Rozesílání upozornění", $username, $lvl);
$page->generate_header();

if ($lvl < AUTH_ADMIN && $_SERVER["REMOTE_ADDR"] != $host_allow) {
	if ($lvl == 0)
		$auth->print_must_login();
	else
		$auth->print_access_denied();
	$page->generate_footer();
	exit;
}


$aktual = new Aktuality(A_AKCE);

if ($_SERVER["REMOTE_ADDR"] == $host_allow || $_GET["force"]+0 == 1) {
	echo "<div class=success>e-maily byly rozeslány ".date("Y-m-d H:i:s", time())."</div>\n";
	$preview = false;
} else {
	echo "<div class=error>e-maily nebyly rozeslány, toto je pouze ukázka\n"
		."toho, co se bude rozesílat v 5 hodin ráno.</div>\n";
	$preview = true;
}

/****************************************************************************/

echo "\n<h2>Upozornění na akce</h2>\n";
$data = $aktual->get(date("Y-m-d H:i:s", time()), 2, false);

if ($data == null) {
	/* zadne akce -> zadny mail */
	echo "<div class=info>Není na co upozorňovat, nic nebylo rozesláno.</div>\n";
} else {
	while($data != null) {
		/* generovani popisu akce */
		$subj = "Upozornění na akci od ".$data['date_start'];
		$query = "SELECT infomail, mail, jmeno, prijmeni, prezdivka\n"
			."FROM `T_Kontakty`\n"
			."LEFT JOIN `T_Ucast` ON T_Ucast.user_id = T_Kontakty.id_user\n"
			."WHERE infomail = 1\n"
			."	AND mail != ''\n"
			."	AND aktuality_id = ".($data['id']+0)."\n"
			."ORDER BY user_id;";

		create_mail($aktual, $subj, $data, $query, $preview, false);

		/* dalsi atualita */
		$data = $aktual->get_next();
	}
}

/****************************************************************************/

echo "<h2>Nová/upravená aktualita</h2>";

if (isset($_GET['storno'])) {
	$storno = $_GET['storno']+0;
	if ($storno > 0) {
		$db->query("UPDATE T_Aktuality SET is_sent = 1 WHERE id = '".$storno."'");
	}
}

$aktual->type = A_ALL;
$data = $aktual->get("1970-1-1 0:0:1", -1, true);

if ($data == null) {
	/* zadne akce -> zadny mail */
	echo "<div class=info>Není na co upozorňovat, nic nebylo rozesláno.</div>\n";
} else {
	while($data != null) {
		$subj = "Nová/upravená aktualita od ".$data['date_start'];
		$query = "SELECT infomail, mail, jmeno, prijmeni, prezdivka\n"
			."FROM `T_Kontakty`\n"
			."WHERE infomail = 1\n"
			."	AND mail != ''\n"
			."ORDER BY user_id;";

		create_mail($aktual, $subj, $data, $query, $preview, true);

		if (!$preview)
			$aktual->mark_sent($data['id']);

		/* dalsi atualita */
		$data = $aktual->get_next();
	}
}



/****************************************************************************/

$page->generate_footer();
?>
