<? // vim:encoding=utf8:
require_once "lib/auth.inc.php";
require_once "lib/page.inc.php";
require_once "lib/editor.inc.php";
require_once "lib/forum.inc.php";
require_once "lib/object_type.inc.php";

/*** page init **************************************************************/

$auth = new Auth();
$lvl = $auth->check_login();
$page = new Page("Fórum: přidání příspěvku", $auth->get_username(), $lvl);
if ($lvl < AUTH_BASIC) {
	$page->generate_header();
	if ($lvl == 0)
		$auth->print_must_login();
	else
		$auth->print_access_denied();
	$page->generate_footer();
	exit;
}

$parent = 1 * $_POST['parent'] + 1 * $_GET['parent'];
$id = 1 * $_POST['id'] + 1 * $_GET['id'];
$type = 1 * $_POST['type'] + 1 * $_GET['type'];

if (isset($_POST['title'])) {
	$p = array('<',    '>',    '"');
	$r = array('&lt;', '&gt;', '&quot;');
	$_POST['title'] = str_replace($p, $r, $_POST['title']);
}

/*** init formulare *********************************************************/

if ($parent > 0) {
	$prev = new Forum($id, $type);
	$prev_item = $prev->get_by_id($parent);
	$def_title = $prev_item['title'];
	if (substr($def_title, 0, 4) != "Re: ")
		$def_title = "Re: ".$def_title;
} else {
	$def_title = "";
}

$def = array('title' => $def_title, 'text'=>'');
$ed = new Editor($_POST, $def, 1, $auth->get_userid());
$ed->add_text_entry("title", "Nadpis", true, 200);
$ed->add_text_area("text", "Text", true);
$ed->add_hidden("parent", $parent);
$ed->add_hidden("id", $id);
$ed->add_hidden("type", $type);

/*** stranka ****************************************************************/

$page->generate_header();
//$ed->dump_data();
if ($ed->is_completed()) {
	$val = $ed->get_values();

	$forum = new Forum($id, $type);
	if ($new_id = $forum->insert($parent, $auth->get_userid(), $val['title'], $val['text'])) {
		$ed->log_post();
		echo 	 "<div class=success>\n"
			."<h2>Příspěvek byl vložen.</h2>\n"
			."<p><a href='forum.php?id=$id&type=$type#$new_id'>Pokračovat v diskuzi</a></p>"
			."</div>\n";
		$forum->show_object($new_id);
	} else {
		echo 	 "<div class=error>\n"
			."<h2>Příspěvek se nepovedlo vložit.</h2>\n"
			."</div>\n";
		$ed->render_form();
	}
} else {
	if ($parent == 0) {
		$obj = new Object_Type($type);
		$obj->show($id);
	} else {
		echo "<div class=forum>\n";
		$prev->render_item($prev_item, false, 0, false);
		echo "</div>\n";
	}
	echo "<h2>Odpověď:</h2>";
	$ed->render_form();
}


/*** page cleanup ***********************************************************/
$page->generate_footer();

?>
