<? // vim:encoding=utf8:
require_once "lib/page.inc.php";
require_once "lib/auth.inc.php";
require_once "lib/freebusy.inc.php";
require_once "lib/kalendar.inc.php";
require_once "lib/editor.inc.php";
require_once "config.php";

foreach (array('id', 'b_d', 'b_m', 'b_y', 'e_d', 'e_m', 'e_y') as $v) {
	if (isset($_GET[$v]) && !isset($_POST[$v])) $_POST[$v] = $_GET[$v];
}

if (isset($_POST['id'])) {
	$id = $_POST['id'];
}

$month = date("n");
$year = date("Y");
$max_day = date("t");

/****************************************************************************/

$auth = new Auth();
$lvl = $auth->check_login();
$page = new Page("Free/Busy", $auth->get_username(), $lvl);
$page->generate_header();
if ($lvl < AUTH_NOBODY) {
	if ($lvl == 0)
		$auth->print_must_login();
	else
		$auth->print_access_denied();
	$page->generate_footer();
	exit;
}

$fb = new FreeBusy($month, $year);

/****************************************************************************/
echo "<h1>Úprava informace o obsazaném/volném čase</h1>\n";
if ($id) {
	$d = $fb->get_event($id, $auth->get_userid());
	list($def['b_y'], $def['b_m'], $def['b_d']) = explode("-", $d["begin"], 3);
	list($def['e_y'], $def['e_m'], $def['e_d']) = explode("-", $d["end"], 3);
	$def['symbol'] = $d["symbol"];
	$def['desc'] = $d["desc"];
	$def['timeis'] = $d["is_free"];
	$def['reptype'] = $d["reptype"];
	$def['repvar_w'] = $d["repvar1"];
	$def['repvar_m1'] = $d["repvar1"];
	$def['repvar_m2'] = $d["repvar2"];
} else {
	$def = array();
}

$ed = new Editor($_POST, $def, $auth->get_userid(), 78);
$ed->add_hidden('id');
$ed->add_label('Základní:');
$ed->add_date_entry('b', 'Od', true, true);
$ed->add_date_entry('e', 'Do', true, true);
$ed->add_combo('timeis', 'Tento čas je', array("obsazený" => 0, "volný" => 1), true);
$ed->add_text_entry('symbol', 'Symbol', true, 5);
$ed->add_text_entry('desc', 'Popis (volitelné)', false, 30);
$ed->add_label('Opakování:');
$ed->add_raw_items(array(
		array('reptype', 'Typ opakování', true),
		array('repvar_w', 'Den týdne', false),
		array('repvar_m1', 'Začátek v měsíci', false),
		array('repvar_m2', 'Konec v měsíci', false)
	));
$d = $ed->get_values();
$ed->add_raw_html(
	 "<tr><th><input type=radio name=reptype id=repnone".($d['reptype'] == 0 ? " checked" : "")." value=0>\n"
	."	<label for=repnone>Žádné</label></th><td>&nbsp;</td>\n"
	."<tr><th><input type=radio name=reptype id=repweek".($d['reptype'] == 1 ? " checked" : "")." value=1>\n"
	."	<label for=repweek>Týdení</label></th>\n"
	."	<td>\n"
	."	<select name=\"repvar_w\">\n"
	."		<option value=\"NULL\"".($d['repvar_w']==0 ? " selected" : "").">&nbsp;</option>\n"
	."		<option value=2".($d['repvar_w']==2 ? " selected":"").">pondělí</option>\n"
	."		<option value=3".($d['repvar_w']==3 ? " selected":"").">úterý</option>\n"
	."		<option value=4".($d['repvar_w']==4 ? " selected":"").">středa</option>\n"
	."		<option value=5".($d['repvar_w']==5 ? " selected":"").">čtvrtek</option>\n"
	."		<option value=6".($d['repvar_w']==6 ? " selected":"").">pátek</option>\n"
	."		<option value=7".($d['repvar_w']==7 ? " selected":"").">sobota</option>\n"
	."		<option value=1".($d['repvar_w']==1 ? " selected":"").">neděle</option>\n"
	."	</select>\n"
	."	</td>\n"
	."<tr><th><input type=radio name=reptype id=repmonth".($d['reptype']==2?" checked":"")." value=2>\n"
	."	<label for=repmonth>Měsíční</label></th>\n"
	."	<td>\n"
	."	od <input name=\"repvar_m1\" value=\"".($d['reptype']==2?($d['repvar_m1']%31):"")."\""
				." maxlength=2 size=2>.\n"
	."	do <input name=\"repvar_m2\" value=\"".($d['reptype']==2?($d['repvar_m2']%31):"")."\""
				." maxlength=2 size=2>.\n"
	."	dne měsíce</td>\n"

);

//$ed->dump_data();
if ($ed->is_completed()) {
	$d = $ed->get_values();
	/* upravy dat */
	switch($d['reptype']) {
		case 0:	// zadne opakovani
			$repvar1 = 0;
			$repvar2 = 0;
			break;
		case 1: // tydne
			$repvar1 = $d['repvar_w'];
			$repvar2 = 0;
			break;
		case 2: // mesicne
			$repvar1 = $d['repvar_m1'];
			$repvar2 = $d['repvar_m2'];
			break;
	}
	/* smazani stareho zaznamu */
	if ($id) {
		$fb->del_event($d['id'], $auth->get_userid());
	}


	/* ulozeni noveho zaznamu */
	if ($fb->add_event($d['b_y']."-".$d['b_m']."-".$d['b_d'], $d['e_y']."-".$d['e_m']."-".$d['e_d'], $d['timeis'],
			$d['symbol'], $d['desc'], $auth->get_userid(),
			$d['reptype'], $repvar1, $repvar2)) {
		echo "<div class=success><h2>Záznam byl uložen</h2>\n"
			."<p><a href='freebusy-list.php'>Správa informací o obsazeném čase</a></p>\n"
			."<p><a href='freebusy.php?month=".$d['b_m']."&year=".$d['b_y']."'>"
				."Přehled na ".get_month_by_number($d['b_m'])." ".$d['b_y']."</a></p>\n"
			."<p><a href='freebusy-edit.php'>Vložit nový záznam</a></p>\n"
			."</div>\n";
	} else {
		echo "<div class=error><h2>Záznam se nepovedlo uložit</h2>\n"
			."<p><a href='freebusy-list.php'>Správa informací o obsazeném čase</a></p>\n"
			."</div>\n";
	}
} else {
	$ed->render_form();
}

$page->generate_footer();
?>
