<? // vim:encoding=utf8:
require_once "lib/page.inc.php";
require_once "lib/auth.inc.php";
require_once "lib/freebusy.inc.php";
require_once "lib/aktuality.inc.php";
require_once "lib/kalendar.inc.php";
require_once "lib/user.inc.php";
require_once "config.php";

/* Predani parametru */
if (isset($_GET["month"]))
	$month = $_GET["month"];
else
	$month = date('n');

if (isset($_GET["year"]))
	$year = $_GET["year"];
else
	$year = date('Y');
	
if (isset($_GET["showall"]))
	$showall = $_GET["showall"] == '1' ? 1 : 0;
else
	$showall = 0;

$debug = $_GET['debug'] == "1";
$PHP_SELF = $_SERVER['PHP_SELF'];

/* Autentizace */
$auth = new Auth();
$lvl = $auth->check_login();

/* Stranka */
$page = new Page("Free/Busy", $auth->get_username(), $lvl);
$page->generate_header();

/* Autorizace */
if ($lvl < AUTH_BASIC) {
	if ($lvl == 0)
		$auth->print_must_login();
	else {
		$auth->print_access_denied();
		echo "<div class=\"info\"><a href=\"freebusy-list.php\">Free/Busy - správa událostí</a></div>";
	}
	$page->generate_footer();
	exit;
}

/* FreeBusy */
$fb = new FreeBusy($month, $year);

/* Aktuality */
$aktuality = new Aktuality(A_AKCE);

/* User */
$U = new User();

/****************************************************************************/

echo "<h1>".get_month_by_number($month)." ".$year."</h1>";

/* navigace */
echo 	 "<div class=navbar>\n"
	."<a href='".$PHP_SELF."?month=".($month > 1 ? ($month - 1) : 12)
	."&amp;year=".($month > 1 ? $year : ($year - 1))."&amp;showall=".$showall
		.($debug ? "&amp;debug=1":"")."'>"
	."&lt;&nbsp;předchozí</a>\n"
	." | <a href='".$PHP_SELF.'?'."&amp;showall=".$showall.($debug ? "&amp;debug=1":"")."'>aktuální</a>\n"
	." | <a href='".$PHP_SELF."?month=".($month < 12 ? ($month + 1) : 1)
	."&amp;year=".($month < 12 ? $year : ($year + 1))."&amp;showall=".$showall.($debug ? "&amp;debug=1":"")."'>"
	."následující&nbsp;&gt;</a>\n"
	."</div>\n";

/* nacteni aktualit pro vybrany mesic */
$akce = $aktuality->get_month($month, $year, 1);

/* vycuc mesice */
$event = $fb->get_month();

// debug
if ($debug) {
	echo "<table class='OnlyCols' summary=\"Přehled volného a obsazeného času různých lidí.\">";
	$first_line = 1;
	foreach($event as $row) {
		if ($first_line) {
			echo "<thead><tr>";
			foreach($row as $hd => $col) {
				echo "<th>".$hd."</th>";
			}
			echo "</thead><tbody>";
			$first_line = 0;
		}
		echo "<tr>";
		foreach($row as $col) {
			echo "<td>".$col."</td>";
		}
	}
	echo "</tbody></table>";
}

/* zacatek, hlavicka a paticka tabulky */
echo "<table class='kalendar'>\n";
$hd = "<tr><th>Den</th><th>&nbsp;?&nbsp;</th>";
$user = $fb->get_users($showall);
$usercol = array();
$i = 0;
foreach($user as $u) {
	$hd .= "<th>".$U->makelink($u[0], $u[1])."</th>";
	$usercol[$u[0]] = $i++;
}
$hd .= "<th>Den</th><th>Akce</th>\n";
echo "\t<thead>".$hd."</thead>\n<tfoot>".$hd."</tfoot>\n";

/* sestaveni tabulky -- vysledek je 3D pole: [den] [user] [symbol/popisek] */
$fbtab = array();
$fbmask = array();
foreach($event as $i => $ev) {
	$b = $ev["begin_here"] ? $ev["begin_here"] : 1;
	$e = $ev["end_here"] ? $ev["end_here"] : date('t', strtotime($year.'-'.$month.'-1'));

	for ($d = $b; $d <= $e; $d++) {
		$add = 0;
		
		/* test udalosti -- aplikace pravidel opakovani */
		switch ($ev["reptype"]) {
			case 0: /* zadne */
				$add = 1;
				break;
				
			case 1: /* tydeni */
				$dow = date('w', mktime(0, 0, 0, $month, $d, $year)) + 1;
				if ($ev['repvar1'] == $dow) {
					$add = 1;
				}
				break;
				
			case 2: /* mesicni */
				if ($ev['repvar1'] <= $d && $ev['repvar2'] >= $d) {
					$add = 1;
				}
				break;
		}
		
		/* pridani udalosti */
		if ($add) {
			$field = $fbtab[$d][$usercol[$ev["id"]]];
			$symbol = $field[0] ? (substr($field[0], -1) == '+' ? '':'+') : $ev['symbol'];
			$desc = ($field[1] ? ', ':'')
				.($ev['desc'] ? $ev['desc'] : ($ev['symbol'] ? $ev['symbol'] : ''));

			$fbtab[$d][$usercol[$ev["id"]]] = array(
					$field[0].$symbol,
					$field[1].$desc,
					$field[2] | $ev["is_free"]);
			if ($ev['is_free'] == 0)
				$fbmask[$d] = 1;
		}
	}
}

/* vypis tabulky */
echo "<tbody>\n";
for ($d = 1; $d <= date('t', strtotime($year.'-'.$month.'-1')); $d++) {
	echo "\n\t<tr".(date("w", mktime(0, 0, 0, $month, $d, $year)) % 6 == 0
			? " class=\"marked\"":"").">\n";
	$day_col = "\t\t<th class=num".($d == date("d") && $month == date("m") && $year == date("Y")
			? "today":"").">"
			."<a href='freebusy-edit.php?b_d=".$d."&amp;e_d=".$d."&amp;b_m=".$month
				."&amp;e_m=".$month."&amp;b_y=".$year."&amp;e_y=".$year."' "
				."title='Přidat událost v tento den'>"
			.$d."</a></th>\n";
	echo $day_col."\t\t<td>".($fbmask[$d] ? 'x':'&nbsp;')."</td>\n";
	for ($u = 0; $u < count($user); $u++) {
		echo "\t\t<td class=col".((($u + 1) % 2) + 1).">"
			.(isset($fbtab[$d][$u])
				? ($fbtab[$d][$u][1] != "" ? "<acronym title='".$fbtab[$d][$u][1]."'>":"")
					.($fbtab[$d][$u][0] != "" ? $fbtab[$d][$u][0] : ($fbtab[$d][$u][2] ? 'free' : 'busy'))
					.($fbtab[$d][$u][1] != "" ?"</acronym>":""):"&nbsp;")
			."</td>\n";
	}
	echo $day_col."\t\t<td nowrap class=long width='100%'>".$akce[$d]."</td>\n";
}

/* konec tabulky */
echo "</tbody>\n</table>\n";

/* funkce */
echo "<ul>\n";
if ($showall == 1) {
	echo "\t<li><a href='".$PHP_SELF."?month=".$month."&amp;year=".$year."&amp;showall=0".($debug ? '&amp;debug=1':'')."'>"
		."Zobrazit pouze členy s alespoň jedním záznamem</a>\n";
} else {
	echo "\t<li><a href='".$PHP_SELF."?month=".$month."&amp;year=".$year."&amp;showall=1".($debug ? '&amp;debug=1':'')."'>"
		."Zobrazit včetně členů bez záznamu</a>\n";
}
echo     "\t<li><a href='freebusy-list.php'>Správa informací o obsazeném čase</a> &ndash; seznam, úpravy, mazání,...\n"
	."\t<li><a href='freebusy-edit.php'>Přidat novou událost</a>\n"
	."</ul>\n";

echo "<ul>\n";
if (!$showall)
	echo "<li> V tabulce se zobrazují pouze ti, kteří mají uvedený alespoň
	jeden záznam v libovolném měsíci.\n";
echo "<li>Znak '+' (plus) na konci symbolu události znamená, že v ten den je
	událostí více.\n\t<li>Symbolem 'atl' je vyznačena potvrzená účast na akci.\n</ul>";


/* konec */
$page->generate_footer();

?>
