<? // vim:encoding=utf8:

require_once "config.php";
require_once "lib/database.inc.php";
require_once "lib/user.inc.php";

define(A_ALL,	-1);
define(A_AKCE,	0);
define(A_NEWS,	1);

class Aktuality {
	var $db = null;
	var $init_done = false;
	var $result = null;
	var $type = 0;
	var $title = array ("Diskuze k aktualitě", "Diskuze k novince");
	var $type_text = array("akce", "novinka");


	function Aktuality($type = A_AKCE) {
		$this->db = new Database();
		$this->type = $type;
	}

	function get($from = 0, $interval = -1, $unsent = false) {
		$query = array (
			/* akce je aktualni i po dobu jejiho trvani
			 *	- treba jen nekdo chce priject pozdeji */
			/* ALL */
			"SELECT * FROM `T_Aktuality`\n"
			."WHERE \n"
			.($interval != -1
			  ? "	date_start >= '".addslashes($from)."'\n"
			   ."	AND date_start <= ('".addslashes($from)."'"
			   ."		+ INTERVAL ".($interval+0)." DAY )"
			  : "	date_end >= '".addslashes($from)."'\n"
			)
			.($unsent
			  ? "	AND is_sent = 0\n"
			   ."	AND modified < NOW()\n"
			  : ""
			)
			."ORDER BY date_start ASC;",
		
			/* A_AKCE */
			"SELECT *, DATEDIFF(date_start, NOW()) day_to_start FROM `T_Aktuality`\n"
			."WHERE type = '0'\n"
			.($interval != -1
			  ? "	AND date_start >= '".addslashes($from)."'\n"
			   ."	AND date_start <= ('".addslashes($from)."'"
			   ."		+ INTERVAL ".($interval+0)." DAY )"
			  : "	AND date_end >= '".addslashes($from)."'\n"
			)
			.($unsent
			  ? "	AND is_sent = 0\n"
			   ."	AND modified < NOW()\n"
			  : ""
			)
			."ORDER BY date_start ASC;",
			
			/* A_NEWS */
			"SELECT * FROM `T_Aktuality`\n"
			."WHERE type = '1'"
			.($unsent
			  ? "	AND is_sent = 0\n"
			   ."	AND modified < NOW()\n"
			  : ""
			)
			."ORDER BY date_start DESC\n"
			.($from > 0 ? "LIMIT ".$from : "").";"
		);

		$this->result = $this->db->query($query[$this->type + 1]);

		return $this->get_next();
	}

	function get_next() {
		$line = $this->db->fetch($this->result);

		if($line) {
			foreach (array_keys($line) as $key)
				$line[$key] = stripslashes($line[$key]);
			return $line;
		} else {
			return null;
		}
	}

	function get_month($month, $year, $as_links = 0) {

		/* Tahle funkce je urcena pro sestavovani seznamu titulku pro kalendar.
		 */

		/* dotaz do databaze */
		$this->result = $this->db->query(
				"SELECT id, title, DAYOFMONTH(date_start) as start_day, ".
					"DAYOFMONTH(date_end) as end_day, ".
					"MONTH(date_start) as start_month, ".
					"MONTH(date_end) as end_month, ".
					"YEAR(date_start) as start_year, YEAR(date_end) as end_year, ".
					" date_start, date_end ".
				"FROM `T_Aktuality` ".
				"WHERE type = 0 AND (".
					"(YEAR(date_start) = '".$year."' ".
					"AND MONTH(date_start) = '".$month."') ".
					"OR ".
					"(YEAR(date_end) = '".$year."'\n"
					."	AND MONTH(date_end) = '".$month."')) ".
				"ORDER BY date_start"
		);

		
		/* inicializace par promennych */
		$month_titles = array("");
		$last_day = date("t", mktime(0, 0, 0, $month, 1, $year));

		/* plneni pole: pole obsahuje pro kazdy den retezec slepeny z titulku vsech akci */
		while ($event = $this->get_next()) {
			if ($event["start_month"] == $month && $event["start_year"] == $year) {
				/* udalost zacina tento mesic
				 * zobrazime od zacatku udalosti do konce udalosti/mesice */
				for($day = $event["start_day"]; ($day <= $event["end_day"]
					|| $event["end_day"] < $event["start_day"])
					&& $day <= $last_day; $day++)
				{
					if ($as_links) {
						$month_titles[$day] .= ($month_titles[$day] != ""
								? ", " : "")
								."<a href='forum.php?id="
								.$event["id"]."&amp;type=1'>"
								.$event["title"]."</a>";
					} else {
						$month_titles[$day] .= ($month_titles[$day] != ""
								? ", " : "")
								.$event["title"];
					}
				}
			} else if ($event["end_month"] == $month && $event["end_year"] == $year) {
				/* udalost zacala minuly mesic
				 * zobrazime od zacatku mesice do konce udalosti/mesice */
				for($day = 1; $day <= $event["end_day"] && $day <= $last_day; $day++) {
					if ($as_links) {
						$month_titles[$day] .= ($month_titles[$day] != ""
								? ", " : "")
								."<a href='forum.php?parent=-"
								.$event["id"]."'>"
								.$event["title"]."</a>";
					} else {
						$month_titles[$day] .= ($month_titles[$day] != ""
								? ", " : "")
								.$event["title"];
					}
				}
			}
		}

		return $month_titles;
	}

	function get_by_id($id) {

		$this->result = $this->db->query("SELECT * FROM `T_Aktuality` WHERE id = \"".
				addslashes($id)."\""."ORDER BY date_start");

		return $this->get_next();
	}

	function delete_by_id($id) {

		$this->result = $this->db->query("DELETE FROM `T_Aktuality` WHERE id = \"".
				addslashes($id)."\""."ORDER BY date_start");
		
		return $this->result;
	}

	function add($id, $type,  $date_start, $date_end, $fdate, $title, $text, $sraz, $ssebou, $cena, $ps,
			$image_file)
	{

		if ($id) {
			$query = "DELETE FROM `T_Aktuality` WHERE id = ".addslashes($id);
			$this->result = $this->db->query($query);
		}

		$query = "REPLACE INTO `T_Aktuality`\n"
			." (id, type, modified, date_start, date_end,\n"
			."  fdate, title, text, sraz, ssebou, cena, ps, is_sent, image)\n"
			." VALUES (\"".($id+0)."\", \"".
			addslashes($type)."\", "."NOW(), \"".
			addslashes($date_start)."\", \"".addslashes($date_end)."\", \"".
			addslashes($fdate)."\", \"".
			addslashes($title)."\",\n\t\"".addslashes($text)."\",\n\t\"".
			addslashes($sraz)."\", \"".addslashes($ssebou)."\", \"".
			addslashes($cena)."\", \"".addslashes($ps)."\", 0, "
			.($image_file == '' ? "NULL" : "\"".addslashes($image_file)."\"").")";

		$this->result = $this->db->query($query);
		
		$ret = $id == 0 ? $this->db->last_id($this->db) : $id;
		return $ret;
	}

	function mark_sent($id) {

		$query = "UPDATE `T_Aktuality`\n"
			."SET is_sent = 1\n"
			."WHERE id = ".($id+0).";";
	
		$this->db->query($query);
		return $this->db->affected_rows();
	}

	function to_string($data, $link = false, $admin_link = false) {
		$U = new User();

		$str = "<dt><b>".$data["title"]."</b> ";
		if ($data["fdate"] != "")
			$str .= "(".$data["fdate"].")";
		if ($data['day_to_start'] > 0)
			$str .= "\n<div><small>počet dní do začátku: ".$data['day_to_start']."</small></div>";
		$str .= "</dt>\n<dd>\n";
		
		if ($data['image'])
			$str .= "<img alt='[img]' class=akttb src='images/aktuality/".$data['image']."'>\n";
			
		$str .= $data["text"]."\n";
		
		if ($data["sraz"]) {
			$str .= "<p class=\"info\"><b>Sraz:</b>\n".$data["sraz"]."</p>\n";
		}
		
		if ($data["ssebou"]) {
			$str .= "<p class=\"info\"><b>S sebou:</b>\n".$data["ssebou"]."</p>\n";
		}
		
		if ($data["cena"]) {
			$str .= "<p class=\"info\"><b>Cena:</b>\n".$data["cena"]."</p>\n";
		}

		if ($data["type"] == A_AKCE) {
			$r = $this->db->query("SELECT `T_User`.`id` AS user_id, `T_User`.`name` as `user_name`\n"
				."FROM `T_Ucast`\n"
				."LEFT JOIN `T_User` ON `T_Ucast`.`user_id` = `T_User`.`id`\n"
				."WHERE `T_Ucast`.`aktuality_id` = '".$data["id"]."'\n"
				."ORDER BY `T_User`.`name`;");

			if (mysql_num_rows($r) > 0) {
				$str .= "<p class=\"info\"><b>Účast potvrdili:</b> \n";
				$first = 1;
				while ($usr = $this->db->fetch($r)) {
					$str .= ($first ? "" : ", ").$U->makelink($usr['user_id'], $usr["user_name"]);
					$first = 0;
				}
				$str .= "</p>\n";
			}
		}
		
		if ($data["ps"]) {
			$str .= "<p class=\"info\"><small><b>ps:</b> ". 
				"<i>".$data["ps"]."</i></small></p>";
		}
		
		if ($link == true) {
			$str .= "<p class=links><small><a href=\"./forum.php?id=".$data["id"]."&amp;type=1\">".
					($this->title[$data["type"]])."</a>";
			if ($data["type"] == A_AKCE && $data["date_start"] > date("Y-m-d")) {
				$str .= " &nbsp;|&nbsp; ";
				$str .= "<a href=\"ucast.php?sid=".$data["id"]."\">Potvrdit moji účast</a>";
				$str .= " &nbsp;|&nbsp; ";
				$str .= "<a href=\"ucast.php?rid=".$data["id"]."\">Odříct moji účast</a>";
			}
			if ($admin_link) {
				$str .= " &nbsp;|&nbsp; ";
				$str .= "<a href=\"aktuality-edit.php?id=".$data["id"]."\">Upravit</a>";
			}
			$str .= "</small></p>";
		}
		
		$str .= "</dd>\n";

		return $str;
	}

	function aprint($data, $link = true, $admin_link = false) {
		print $this->to_string($data, $link, $admin_link);
	}

	function object_show($id) {
		$i = $this->get_by_id($id);
		if ($i) {
			echo "<dl class=\"aktuality\">\n".$this->to_string($i, true, true)."</dl>\n";
		} else {
			echo "<div class=error>\n<h2>Interní chyba aplikace</h2>\n"
				."<p>Nebyla nalezena zvolená aktualita.</p>\n"
				."</div>\n";
		}
	}
}
?>
