<?
/*
 * auth.inc -- obsluha autentifikace uzivatele
 *
 * Josef Kufner <jkufner@seznam.cz>
 */

require_once "config.php";
require_once "lib/database.inc.php";
require_once "lib/user.inc.php";

define('AUTH_BLOCKED', -1);
define('AUTH_NOBODY',   1);
define('AUTH_BASIC',    2);
define('AUTH_EDITOR',   3);
define('AUTH_ADMIN',    4);
define('AUTH_ROOT',     5);

class Auth {
	var $db;
	var $user_name = "";
	var $user_id = 0;
	var $user_level = 0;
	var $auth = "";

	function Auth() {
		$this->db = new Database();
	}
	function setSQLIDUser(){
		// Do nasi 'transakce' deklarujeme IDUser
		$sql = 'SET @IDUser = '.$this->user_id;
		if (mysql_query($sql))
			show_debug($sql);
	}
	
	function login($user, $passwd) {
		global $HTTP_COOKIE_VARS;
	
		srand(time());
		$auth = rand(0, 99999999).time();

		$r = $this->db->query("SELECT `name`, `id`, `perm_level` FROM `T_User` "
				."WHERE `name`='".addslashes($user)."' "
				."AND `passwd`=SHA('".addslashes($passwd)."') "
				." LIMIT 1;");
		if ($this->db->num_rows($r) == 1) {
			$duser = $this->db->fetch($r);

			// store login hash
			$this->db->query("DELETE FROM `T_Auth` WHERE `user_id`='".$duser["id"]."'");
			$this->db->query("INSERT INTO `T_Auth` (`user_id`, `auth`, `time`) "
				."VALUES ('".$duser["id"]."', '".$auth."', NOW())");
				
			// remove very old form posts
			$this->db->query("DELETE FROM `T_Editor_Post` WHERE `user_id`='".$duser["id"]."' "
				."AND timestamp < NOW() - 259200" /* 3 days */);

			$this->user_id = $duser["user_id"];
			$this->user_name = $duser["name"];
			$this->auth = $auth;
			$this->user_level = $duser["perm_level"];

			$this->setSQLIDUser();

			setcookie("atl_planner_user", $duser["name"], time() + 60*60*4);
			setcookie("atl_planner_auth", $auth, time() + 60*60*4);
			
			return $duser["perm_level"];
		} else {
			return 0;
		}
	}

	function load($id) {
		$r = $this->db->query("SELECT `name`, `id`, `perm_level` FROM `T_User`\n"
				."WHERE `id` = ".intval($id)."\n"
				."LIMIT 1;");
		if ($ln = $this->db->fetch($r)) {
			$this->user_id = $ln['id'];
			$this->user_name = $ln['name'];
			$this->user_level = $ln['perm_level'];
			return true;
		} else {
			return false;
		}
	}

	function check_login () {
		global $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS;
		
		$user = $HTTP_COOKIE_VARS["atl_planner_user"];
		$auth = $HTTP_COOKIE_VARS["atl_planner_auth"];

		/*
		if ($HTTP_SERVER_VARS['REMOTE_ADDR'] == "133.27.228.132") {
			return 2;
		}
		// */

		$r = $this->db->query("SELECT `id`, `name`, `auth`, `perm_level` FROM `T_User` "
				."LEFT JOIN `T_Auth` ON `T_User`.`id` = `T_Auth`.`user_id` "
				."WHERE `name` = '".addslashes($user)."' "
				."AND `auth` = '".addslashes($auth)."' LIMIT 1;");

		if ($this->db->num_rows($r) == 1) {
			$duser = $this->db->fetch($r);
			$this->user_id = $duser["id"];
			$this->user_name = $duser["name"];
			$this->auth = $auth;
			$this->user_level = $duser["perm_level"];
			setcookie("atl_planner_user", $duser["name"], time() + 60*60*4);
			setcookie("atl_planner_auth", $auth, time() + 60*60*4);
			$this->setSQLIDUser();
			return $duser["perm_level"];
		} else {
			return 0;
		}
	}

	function get_username() {
		return $this->user_name;
	}

	function get_userid() {
		return $this->user_id;
	}

	function get_permlevel() {
		return $this->user_level;
	}
	function get_levelnames() {
		return array(
			'účet zakázán' => AUTH_BLOCKED,
			'žádná' => AUTH_NOBODY,
			'čtenář' => AUTH_BASIC,
			'editor' => AUTH_EDITOR,
			'správce' => AUTH_ADMIN,
			'hlavní správce' => AUTH_ROOT
		);
	}

	function new_user ($name, $passwd) {
		$this->db->query("INSERT INTO `T_User` (`name`, `passwd`) "
				."VALUES ('".addslashes($name)."', SHA('".addslashes($passwd)."')) "
				.";");
		if ($this->db->affected_rows() == 1) {
			return true;
		} else {
			return false;
		}
		
	}

	function change_name ($new_name, $passwd) {

		if ($new_name == "")
			return false;
		
		$this->db->query("UPDATE `T_User` SET `name` = '".addslashes($new_name)."' "
				."WHERE `name` = '".addslashes($this->user_name)."' "
				."AND `passwd` = SHA('".addslashes($passwd)."');");
		
		if ($this->db->affected_rows() == 1) {
			$this->user_name = $new_name;
			return true;
		} else {
			return false;
		}
	}

	function change_passwd ($old, $new1, $new2) {

		if ($new1 != $new2)
			return false;
		
		$r = $this->db->query("SELECT `name` FROM `T_User`\n"
				."WHERE `name` = '".addslashes($this->user_name)."'\n"
				."AND `passwd` = SHA('".addslashes($old)."')\n"
				." LIMIT 1;");

		if ($this->db->num_rows($r) == 1) {
			$this->db->query("UPDATE `T_User` SET `passwd` = SHA('".addslashes($new1)."') "
					."WHERE `name` = '".addslashes($this->user_name)."';");
		
			if ($this->db->affected_rows() == 1) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function change_permlevel ($user_id, $new_permlevel) {

		$r = $this->db->query("SELECT `perm_level` FROM `T_User`\n"
				."WHERE `id` = ".intval($user_id)."\n"
				."LIMIT 1;");
		$target_user = $this->db->fetch($r);

		if ($this->user_level < AUTH_ADMIN || $this->user_level < $target_user['perm_level']) {
			return false;
		}

		$this->db->query("UPDATE `T_User` SET `perm_level` = ".intval($new_permlevel)."\n"
				."WHERE `id` = ".intval($user_id)."\n"
				."LIMIT 1");
		
		if ($this->db->affected_rows() == 1) {
			return true;
		} else {
			return false;
		}
	}

	function get_accounts ($show_all = false, $show_disaled = false) {
		$d = array();
		$r = $this->db->query(
			 "SELECT `id`, `name`, `perm_level` FROM `T_User`\n"
			.( $show_all ? ""
				:($show_disaled ? "WHERE perm_level = -1\n"
					: "WHERE perm_level >= 0\n")
			)
			."ORDER BY `name`"
		);
		while ($ln = $this->db->fetch($r))
			$d[] = $ln;
		$this->db->free($r);
		return $d;
	}

	function logout () {
	
		$r = $this->db->query("DELETE FROM `T_Auth` "
				."WHERE `user_id` = '".$this->user_id."'; ");

		$ret = $this->db->affected_rows();

		$this->user_id = 0;
		$this->user_name = "";
		$this->auth = "";
		$this->user_level = 0;
	
		return ($ret > 0);
	}

	function print_must_login() {
		echo "<div class=\"error\">\n";
		echo "<h1>Přístup odepřen</h1>";
		echo "<p>Pro využívání této služby musíš být přihlášen(a)&nbsp;!</p>\n";
		echo "</div>\n";
		echo "<div class=\"info\"><a href=\"./login.php\">přihlásit se</a></div>";
		return true;
	}

	function print_access_denied() {
		echo "<div class=\"error\">\n";
		echo "<h1>Přístup odepřen</h1>";
		echo "<p>Pro využívání této nemáš dostatečná oprávnění&nbsp;!</p>\n";
		echo "</div>\n";
		return true;
	}

}

?>
