<?

require_once "lib/database.inc.php";
require_once "lib/utils.inc.php";

class Editor {
	var $db = null;
	var $post = array();
	var $user_id = 0;
	var $form_number = 0;
	var $form = "";
	var $hidden = "";
	var $group = 2;
	var $data = array();
	var $have_errors = false;
	var $def = array();
	
	function Editor ($post, $def, $form_number, $user_id) {
		$this->db = new Database();
		$this->post = $post;
		$this->def = $def;
		$this->form_number = to_num($form_number);
		$this->user_id = to_num($user_id);
		$this->form =	 "<form action='".$_SERVER['PHP_SELF']."' method='post' enctype='multipart/form-data'>\n"
				."<table width='100%' class='Editor'>\n"
				."<colgroup><col width='0%'><col width='100%'></colgroup>\n";
		$this->data['submit'] = isset($this->post['submit']) ? $this->post['submit'] : '';
	}

	function is_completed() {
		$r = $this->db->query(
			 "SELECT timestamp FROM T_Editor_Post\n"
			."WHERE user_id = ".$this->user_id."\n"
			."	AND form_number = ".$this->form_number."\n"
			."	AND hash = '".md5(implode('', $this->post))."'\n"
		);

		if ($this->db->num_rows($r) > 0) {
			echo "<div class=error><h2>Formulář byl již zpracován.</h2></div>\n";
			return false;
		}
		
		return $this->data['submit'] != "" && !$this->have_errors;
	}

	function log_post() {
		$this->db->query(
			 "INSERT INTO T_Editor_Post (user_id, form_number, hash)\n"
			."VALUES (".to_num($this->user_id).", ".to_num($this->form_number).",\n"
			."'".md5(implode('', $this->post))."')"
		);
		
	}

	function dump_data() {
		echo "<pre>";
		foreach ($this->data as $n => $v)
			echo htmlspecialchars($n)." = \"".htmlspecialchars($v)."\"\n";
		echo "</pre>\n";
	}
	
	function get_values() {
		return $this->data;
	}
	

	function set_group($group) {
		$this->group = $group;
	}

	function add($name, $label, $rq, $value = null) {
		if ($value != null) {
			$this->data[$name] = $value;
		} else {
			$this->data[$name] = isset($this->post[$name]) ?
				(get_magic_quotes_gpc() ? stripslashes($this->post[$name]) : $this->post[$name]) 
				: $this->def[$name];
		}
		if ($rq && $this->data['submit'] != "" && $this->post[$name] == "") {
			$this->error("Položka \"".$label."\" musí být vyplněna!");
			$this->have_errors = true;
			return false;
		}
		return true;
	}

	function check_max_len($name, $label, $max) {
		if ($max != 0 && strlen($this->post[$name]) > $max) {
			$this->error("Položka \"".$label."\" je příliš dlouhá! Maximální délka je ".$max." znaků.");
			$this->have_errors = true;
			return false;
		}
		return true;
	}

	function error($str) {
			$this->form .= "<tr class='group".$this->group."'><th></th>"
				."<td><span class=error>".$str."</span></td>\n";
	}
	
	function add_label($title) {
		$this->form .= "<tr class='group".$this->group."'><th colspan='2' class='label'>".$title."</th>\n";
	}
	
	function add_note($title) {
		$this->form .= "<tr class='group".$this->group."'><th></th><td class='note'>".$title."</td>\n";
	}
	
	function add_text_entry($name, $label, $rq, $maxlen = 0) {
		$this->check_max_len($name, $label, $maxlen);
		$this->add($name, $label, $rq);
		$this->form .=	 "<tr class='group".$this->group."'>\n"
				."	<th>".$label.":</th>\n"
				."	<td><input class=textentry name='".$name."' value=\""
					.htmlspecialchars($this->data[$name])."\""
					." size=40".($maxlen > 0 ? " maxlength=".$maxlen:"").">"
				."</td>\n";
	}

	function add_passwd_entry($name, $label, $rq, $maxlen = 0) {
		$this->check_max_len($name, $label, $maxlen);
		$this->add($name, $label, $rq);
		$this->form .=	 "<tr class='group".$this->group."'>\n"
				."	<th>".$label.":</th>\n"
				."	<td><input type=password class=textentry name='".$name."' value=\""
					.htmlspecialchars($this->data[$name])."\""
					." size=40".($maxlen > 0 ? " maxlength=".$maxlen:"").">"
				."</td>\n";
	}

	function add_text_area($name, $label, $rq) {
		$this->add($name, $label, $rq);
		$this->form .=	 "<tr class='group".$this->group."'>\n"
				."	<th>".$label.":</th>\n"
				."	<td><textarea name='".$name."' cols=40 rows=12>"
				.htmlspecialchars($this->data[$name])."</textarea></td>\n";
	}
	
	function add_date_entry($name, $label, $year, $rq) {
		$this->add($name.'_d', $label.' (den)', $rq);
		$this->add($name.'_m', $label.' (měsíc)', $rq);
		$this->add($name.'_y', $label.' (rok)', $rq);
		$this->form .=
			 "<tr class='group".$this->group."'>\n"
			."	<th>".$label.":</th>\n"
			."	<td>"
			."\t<input class=date name='".$name."_d' value=\"".htmlspecialchars($this->data[$name.'_d'])
					."\" size=2 maxlength=2 title='Den'>. "
			."\t<input class=date name='".$name."_m' value=\"".htmlspecialchars($this->data[$name.'_m'])
					."\" size=2 maxlength=2 title='Měsíc'>. "
			.($year ? "\t<input class=date name='".$name."_y' value=\"".htmlspecialchars($this->data[$name.'_y'])
					."\" size=4 maxlength=4 title='Rok'>":"")
			."</td>\n";
	}

	function add_datetime_entry($name, $label, $year, $rq) {
		$this->add($name.'_d', $label.' (den)', $rq);
		$this->add($name.'_m', $label.' (měsíc)', $rq);
		$this->add($name.'_y', $label.' (rok)', $rq);
		$this->add($name.'_H', $label.' (hodina)', $rq);
		$this->add($name.'_M', $label.' (minuta)', $rq);
		$this->add($name.'_S', $label.' (sekunda)', $rq);
		$this->form .=
			 "<tr class='group".$this->group."'>\n"
			."	<th>".$label.":</th>\n"
			."	<td>"
			."<input class=date name='".$name."_d' value=\"".htmlspecialchars($this->data[$name.'_d'])
					."\" size=2 maxlength=2 title='Den'>.&nbsp;"
			."<input class=date name='".$name."_m' value=\"".htmlspecialchars($this->data[$name.'_m'])
					."\" size=2 maxlength=2 title='Měsíc'>.&nbsp;"
			.($year ? "<input class=date name='".$name."_y' value=\"".htmlspecialchars($this->data[$name.'_y'])
					."\" size=4 maxlength=4 title='Rok'>":"")
			."\n\t&nbsp;&nbsp;"
			."\t<input class=date name='".$name."_H' value=\"".htmlspecialchars($this->data[$name.'_H'])
					."\" size=2 maxlength=2 title='Hodina'>&nbsp;:&nbsp;"
			."<input class=date name='".$name."_M' value=\"".htmlspecialchars($this->data[$name.'_M'])
					."\" size=2 maxlength=2 title='Minuta'>&nbsp;:&nbsp;"
			."<input class=date name='".$name."_S' value=\"".htmlspecialchars($this->data[$name.'_S'])
					."\" size=2 maxlength=2 title='Sekunda'>"
			."</td>\n";
	}

	function add_number_line($name, $label, $size, $rq) {
		$this->form .=
			 "<tr class='group".$this->group."'>\n"
			."	<th>".$label.":</th>\n"
			."	<td>";
		foreach ($size as $i => $s) {
			$this->add($name.$i, $label, $rq);
			$this->form .= "\t<input class=date name='".$name.$i."' value=\""
					.htmlspecialchars($this->data[$name.$i])
					."\" size=$s maxlength=$s>&nbsp; ";
		}
		$this->form .= "</td>\n";
	}

	function add_combo($name, $label, $item, $rq) {
		$this->add($name, $label, $rq);
		$this->form .=
			 "<tr class='group".$this->group."'>\n"
			."	<th>".$label.":</th>\n"
			."	<td><select name='".$name."'>\n";
		$selected = false;
		foreach ($item as $t => $v) {
			if (!$selected && $v == $this->data[$name]) {
				$this->form .= "\t<option value='".$v."' selected>".$t."</option>\n";
				$selected = true;
			} else {
				$this->form .= "\t<option value='".$v."'>".$t."</option>\n";
			}
		}
		$this->form .= "</select></td>\n";
	}

	function add_hidden($name, $value = null) {
		$this->add($name, "", false, $value);
		$this->hidden .= "<input type='hidden' name='".$name."' value=\"".htmlspecialchars($this->data[$name])."\">\n";
	}

	function add_image_store($name, $label, $imgbasedir) {
		$this->add($name.'_src', $label, false);
		$this->add($name.'_url', $label, false);
		$this->add($name.'_actual', $label, false);
		$this->form .= 
			 "<tr class='group".$this->group."'>\n"
			."\t<td><input id='".$name."-none' type=radio name='".$name."_src' value='none'"
				.($this->data[$name.'_src'] == 'none' ? " checked":"")
				."><label for='".$name."-none'>žádný</label></td>\n"
			."\t<td>&nbsp;</td>\n"
			."<tr class='group".$this->group."'>\n"
			/*
			."\t<td><input id='".$name."-upload' type=radio name='".$name."_src' value=upload>\n"
			."\t\t<label for='".$name."-upload'>upload:</label></td>\n"
			."\t<td><input class='image' name='".$name."_file' value='' type='file'></td>\n"
			."<tr class='group".$this->group."'>\n"
			*/
			."\t<td valign=top><input id='".$name."-url' type=radio name='".$name."_src' value='url'"
				.($this->data[$name.'_src'] == 'url' ? " checked":"")
				."><label for='".$name."-url'>URL:</label></td>\n"
			."\t<td valign=top><input name='".$name."_url' "
					."value=\"".htmlspecialchars($this->data[$name.'_url'])."\" "
					."class='image'></td>\n"
			."</tr>\n";
			if ($this->data[$name.'_src'] == 'actual') {
			$this->form .= 
				"<tr class='group".$this->group."'>\n"
				."\t<td><input id='".$name."-actual' name='".$name."_src' type=radio value='actual'"
					."checked><label for='".$name."-actual'>Aktuální obrázek:</label></td>\n"
				."\t<td><img src=\"".$imgbasedir.htmlspecialchars($this->data[$name.'_actual'])."\" "
					."alt=\"".$imgbasedir.htmlspecialchars($this->data[$name.'_actual'])."\" "
					."title=\"".$imgbasedir.htmlspecialchars($this->data[$name.'_actual'])."\">"
						."</td>\n"
				."</tr>\n";
				$this->hidden .= "<input type='hidden' name='".$name."_actual' "
					."value=\"".htmlspecialchars($this->data[$name.'_actual'])."\">\n";
			}
	}
	
	function add_raw_items($field_array) {
		foreach($field_array as $f) {
			$this->add($f[0], $f[1], $f[2]);
		}
	}
	function add_raw_html($html) {
		$this->form .= $html;
	}

	function render_form() {
		echo	$this->form
			."<tr><th colspan=2><hr></th>"
			."<tr><th></th><td>".$this->hidden."<input type=submit name='submit' value='Submit Query'>"
			."</table>\n"
			."</form>\n";
	}

}

?>
