<?
require_once "config.php";
require_once "database.inc.php";
require_once "utils.inc.php";
require_once "user.inc.php";

class Forum {
	var $object_id;
	var $object_type;
	var $db;
	var $debug = false;
	var $usr;
	
	function Forum($object_id = -1, $object_type = -1, $debug = false) {
		$this->db = new Database();
		$this->object_id = to_num($object_id);
		$this->object_type = to_num($object_type);
		$this->debug = to_num($debug);
		$this->usr = new User();
	}

	function render_item($item, $is_unread = false, $unread_no = 0, $can_response = true) {
		echo "<a name=\"forum".$item["id"]."\"></a>";
		if ($is_unread)
			echo "<a name=\"unread".($unread_no)."\"></a>";
		echo "<table width=\"100%\" class='forum".($is_unread ? 'new' : '')."'>\n";

		/*
		echo "<tr><td colspan=2><pre>";
		foreach($item as $k => $v)
			echo "$k = $v\n";
		echo "</pre></td><tr>";
		*/
		if ($item['user_id'] > 0) {
			echo "<tr><td>Autor:</td><td width=\"100%\">"
				.$this->usr->makelink($item["user_id"], $item["author"])."</td>\n";
		} else if ($item["email"] != '') {
			echo "<tr><td>Autor:</td><td width=\"100%\"><a href=\"mailto:".
				$item["email"]."\">".
				$item["author"]."</a></td>\n";
		} else {
			echo "<tr><td>Autor:</td><td width=\"100%\">".$item["author"]."</td>\n";
		}
			
		echo "<td nowrap class=\"right\">".$item["date"]."</td>\n";
		
		if ($item["www"])
			echo "<tr><td>web:</td><td colspan=\"2\"><a href=\""
				.$item["www"]."\" target=\"_new\">"
				.$item["www"]."</a></td>\n";
			
		if ($item['title']) {
			echo "<tr><td>nadpis:</td><td colspan=\"1\">".$item["title"]."</td>"
				.(($item["can_response"] && $can_response)
					? "<td class=\"right\" nowrap>"
					."<a href=\"forum-edit.php?parent=".$item["id"]
						."&amp;id=".$this->object_id
						."&amp;type=".$this->object_type."\">odpovědět</a>"
					." | <a href=\"forum.php?id=".$this->object_id
						."&amp;type=".$this->object_type
						."#forum".$item["id"]."\">link</a>"
					.($is_unread ? " | <a href='#unread".($unread_no+1)."'>další</a>":"")
					."</td>"
					: "")
				."\n";
		}
		if ($this->debug) {
			echo "<tr><td colspan=3><small><tt>id = ".$item['id'].", "
				."parent = ".$item['parent'].", "
				."left = ".$item['pos_left'].", "
				."right = ".$item['pos_right'].", "
				."object_id = ".$item['object_id'].", "
				."object_type = ".$item['object_type']
				."</tt></small></td>\n";
		}
		echo "</table>\n";
		echo $item["text"]."\n";
	}

	function render_thread($user_id, $can_response) {

		$user_id = to_num($user_id);

		if ($this->object_id > 0) {
			$r = $this->db->query(
				 "SELECT UNIX_TIMESTAMP(date) as ts\n"
				."FROM T_Forum_LastView\n"
				."WHERE object_id = ".$this->object_id."\n"
				."	AND object_type = ".$this->object_type."\n"
				."	AND object_type = ".$this->object_type."\n"
				."	AND user_id = ".$user_id."\n"
				."LIMIT 1\n"
			);
			if ($item = $this->db->fetch($r)) {
				$highlight_newer = $item['ts'];
			}
		}
		
		$r = $this->db->query(
			 "SELECT T_Forum.id, T_Forum.object_id, T_Forum.object_type,\n"
			."	T_Forum.parent, T_Forum.pos_left, T_Forum.pos_right,\n"
			."	T_Forum.user_id, T_Forum.can_response,\n"
			." 	T_Forum.date, T_Forum.title, T_Forum.text,\n"
			."	T_Forum.email, T_Forum.www,\n"
			."	IF (T_Forum.user_id > 0, T_User.name, T_Forum.author) AS author,\n"
			."	UNIX_TIMESTAMP(date) as date_timestamp\n"
			."FROM T_Forum\n"
			."LEFT JOIN T_User ON T_User.id = T_Forum.user_id\n"
			.($this->object_id > 0 ?
				"WHERE object_id = ".$this->object_id." AND object_type = ".$this->object_type."\n"
				:""
			)
			."ORDER BY pos_left\n"
		);
		$unread_no = 1;

		$st = array();
		$p = -1;
		$div = 0;
		$unread_no = 1;
		while ($item = $this->db->fetch($r)) {
			$is_unread = ($highlight_newer > 0 && $item["date_timestamp"] > $highlight_newer);

			if ($p < 0) {
				/* toplevel */
				$p = 0;
			} elseif ($last_parent == $item['parent']) {
				/* same level */
				echo "</div>\n";
			} elseif ($st[$p] == $item['parent']) {
				/* child */
				$p++;
			} else {
				/* parent's child */
				while ($p > 0 && $st[$p - 1] != $item['parent']) {
					echo "</div>\n";
					$p--;
				}
				echo "</div>\n";
			}
			$st[$p] = $item['id'];
			
			echo "<div class=\"forum\">\n";
			$this->render_item($item, $is_unread, $unread_no, $can_response);
			if ($is_unread)
				$unread_no++;
			$last_parent = $item['parent'];
		}
		while ($p >= 0) {
			echo "</div>\n";
			$p--;
		}
		//echo "<a name=\"unread".($unread_no)."\"></a>";
	}

	function get_by_id($id) {
		$r = $this->db->query(
			 "SELECT T_Forum.*, IF (T_Forum.user_id IS NULL, author, T_User.name) AS author\n"
			."FROM T_Forum\n"
			."LEFT JOIN T_User ON T_User.id = T_Forum.user_id\n"
			."WHERE T_Forum.id = ".to_num($id)."\n"
			."LIMIT 1\n"
		);
		return $this->db->fetch($r);
	}

	function get_count_total() {
	}

	function get_count_unread() {
		/* last view form T_Forum_LastView */
	}

	function insert($parent, $user_id, $title, $text) {
		$parent = to_num($parent);
		$user_id = to_num($user_id);

		if ($parent == 0) {
			$r = $this->db->query(
				 "SELECT pos_right\n"
				."FROM T_Forum\n"
				."WHERE object_id = ".$this->object_id."\n"
				."	AND object_type = ".$this->object_type."\n"
				."ORDER BY pos_right DESC\n"
				."LIMIT 1"
			);
			if ($d = $this->db->fetch($r))
				$pos = $d['pos_right'] + 1;
			else 
				$pos = 1;
		} else {
			if ($p = $this->get_by_id($parent)) {
				$pos = $p['pos_right'];
			} else {
				return 0;
			}
			$this->db->query(
				 "UPDATE T_Forum\n"
				."SET pos_right = pos_right + 2\n"
				."WHERE object_id = ".$this->object_id."\n"
				."	AND object_type = ".$this->object_type."\n"
				."	AND pos_right >= $pos\n"
			);
			$this->db->query(
				 "UPDATE T_Forum\n"
				."SET pos_left = pos_left + 2\n"
				."WHERE object_id = ".$this->object_id."\n"
				."	AND object_type = ".$this->object_type."\n"
				."	AND pos_left > ".($pos)."\n"
			);
		}
		$this->db->query(
			 "INSERT INTO T_Forum\n"
			."	(parent, object_id, object_type,\n"
			."	user_id, date, title, text,\n"
			."	pos_left, pos_right)\n"
			."VALUES ($parent, ".$this->object_id.", ".$this->object_type.",\n"
			."	$user_id, NOW(), '".addslashes($title)."', '".addslashes(nl2br($text))."',\n"
			."	$pos, ".($pos + 1).")\n"
		);
		$id =  $this->db->last_id();
		return $id;
	}

	function get_lasts($user_id = null, $limit = 10) {
		$r = $this->db->query(
			 "SELECT T_Forum.id AS id, object_id, object_type, T_Object_Type.name as type_name,\n"
			."	IF(T_Forum.user_id, T_User.name, author) AS author, T_Forum.user_id AS user_id,\n"
			."	T_Forum.date, CONCAT(MONTH(T_Forum.date), ' / ', YEAR(T_Forum.date)) as `month`,\n"
			."	IF(T_Forum.title <> '', T_Forum.title, \n"
			."		CONCAT('<i>(bez nadpisu)</i> ', SUBSTRING(T_Forum.text, 1, 40),\n"
			."		IF(LENGTH(T_Forum.text) > 40, '...', '')))\n"
			."		as title,\n"
			."	T_Forum.text\n"
			//."	,IF(T_Topic.name IS NOT NULL, T_Topic.name, T_Aktuality.title) as object_title\n"
			."FROM T_Forum\n"
			."LEFT JOIN T_User ON T_User.id = T_Forum.user_id\n"
			."LEFT JOIN T_Object_Type ON T_Forum.object_type = T_Object_Type.id\n"
			//."LEFT JOIN T_Topic ON T_Topic.id = T_Forum.object_id\n"
			//."LEFT JOIN T_Aktuality ON T_Aktuality.id = T_Forum.object_id\n"
			.($user_id ? "WHERE user_id = ".to_num($user_id)."\n":"")
			."ORDER BY date DESC\n"
			.($limit > 0 ? "LIMIT ".to_num($limit) : "")
		);
		$item = array();
		for ($i = 0; $d = $this->db->fetch($r); $i++) {
			$item[$i] = $d;
			$item[$i][0] = $d['type_name'];
			$item[$i][1] = "<a href='forum.php?id=".$d['object_id']."&amp;type=".$d['object_type']
					."#".$d['id']."'>".$d['title']."</a>";
			$item[$i][2] = $d['user_id'] > 0 ? $this->usr->makelink($d["user_id"], $d["author"])
					: $d["author"];
			$item[$i][3] = str_replace(' ', '&nbsp;', $d['date']);
		}
		return $item;
	}
	function get_lasts_tabledef() {
		return array(
			'head' => array (
				'Typ',
				'Nadpis&nbsp;příspěvku',
				'Autor',
				'Datum&nbsp;vložení',
			),
			'cols' => array(0, 1, 2, 3),
			'foot' => array(),
			'col_width' => array()
		);
	}

	function show_object($id) {
		echo "<div class='forum'>\n";
		$this->render_item($this->get_by_id($id), false, 0, false);
		echo "</div>";
	}
}

?>
