<?php

require_once "config.php";
require_once "lib/database.inc.php";

class FreeBusy {
	var $db;
	var $month = 0;
	var $year = 0;
	var $list_result;
	
	function FreeBusy($month, $year) {
		$this->db = new Database();
		$this->month = is_numeric($month) && $month > 0 ? $month : date('m');
		$this->year = is_numeric($year) && $year > 0 ? $year : date('Y');
	}

	/* vrati seznam lidi v kalendari ve stejnem poradi jako get_day 
	 * vraci 2D pole: array( id, jmeno ) */
	function get_users($all = 0) {
		$ret = array();
		if ($all) {
			$query = "SELECT `id`, `name` FROM T_User ORDER BY `name`;";
		} else {
			$query = "SELECT `T_User`.`id`, `name` FROM T_User\n"
				."LEFT JOIN T_FreeBusy ON `T_User`.`id` = `T_FreeBusy`.`user_id`\n"
				."WHERE `begin` >= '".$this->year."-".$this->month."-1'\n"
				."	OR `end` <= '".$this->year."-".$this->month."-31'\n"
				."GROUP BY `id`\n"
				."ORDER BY `name`;";
		}
		$result = $this->db->query($query);
		$i = 0;
		while ($ln = $this->db->fetch($result)) {
			$ret[$i++] = array($ln['id'], $ln['name']);
		}
		$this->db->free($result);
		return $ret;
	}

	
	/** posle query na dany mesic 
	 * Vraci 2D pole, ktere je primo vycucem z DB -- vraci jen udalosti
	 * vyskytujici se dany mesic. Volajici fn musi data narovnat do
	 * kalendare sama -- vyrazne to zjednodusi sql a umozni delat
	 * krkolomejsi opakovani eventu
	 */
	function get_month() {
		$ret = array();

		/* udalosti */
		$q = array(
			"SELECT T_User.id AS `id`,\n"
			."	T_FreeBusy.symbol AS `symbol`, T_FreeBusy.description AS `desc`,\n"
			."	T_FreeBusy.begin AS `begin`,\n"
			."	(T_FreeBusy.begin >= '".$this->year."-".$this->month."-1')\n"
			."		* DAY(T_FreeBusy.begin) AS `begin_here`,\n"
			."	T_FreeBusy.end AS `end`,\n"
			."	(T_FreeBusy.end < '".$this->year."-".$this->month."-1' + INTERVAL 1 MONTH)\n"
			."		* DAY(T_FreeBusy.end) AS `end_here`,\n"
			."	T_FreeBusy.is_free AS `is_free`,\n"
			."	T_FreeBusy.reptype AS `reptype`,\n"
			."	T_FreeBusy.repvar1 AS `repvar1`, T_FreeBusy.repvar2 AS `repvar2`\n"
			."FROM T_User\n"
			."LEFT JOIN T_FreeBusy ON T_User.id = T_FreeBusy.user_id\n"
			."WHERE T_FreeBusy.begin < '".$this->year."-".$this->month."-1' + INTERVAL 1 MONTH\n"
			."	AND T_FreeBusy.end >= '".$this->year."-".$this->month."-1'\n"
			."ORDER BY T_User.name, T_User.id, T_FreeBusy.begin",
			
			"SELECT\n"
			."	T_Ucast.user_id AS id,\n"
			."	'atl' AS symbol,\n"
			."	T_Aktuality.title AS `desc`,\n"
			."	DATE(T_Aktuality.date_start) AS begin,\n"
			."	(T_Aktuality.date_start >= '".$this->year."-".$this->month."-1')\n"
			."		* DAY(T_Aktuality.date_start) AS `begin_here`,\n"
			."	DATE(T_Aktuality.date_end) AS end,\n"
			."	(T_Aktuality.date_end < '".$this->year."-".$this->month."-1' + INTERVAL 1 MONTH)\n"
			."		* DAY(T_Aktuality.date_end) AS `end_here`,\n"
			."	0 AS `is_free`, 0 AS `reptype`, 0 AS `repvar1`, 0 AS `repvar2`"
			."FROM T_Ucast\n"
			."LEFT JOIN T_Aktuality ON T_Ucast.aktuality_id = T_Aktuality.id\n"
			."WHERE T_Aktuality.date_start < '$this->year-$this->month-1' + INTERVAL 1 MONTH\n"
			."	AND T_Aktuality.date_end >= '$this->year-$this->month-1'\n"
			."	AND state = 1\n"
		);
		
		$i = 0;
		foreach($q as $query) {
			$result = $this->db->query($query);
			//echo "<pre>".$query."</pre>";
			for (; $ln = $this->db->fetch($result); $i++) {
				$ret[$i] = $ln;
			}
			$this->db->free($result);
		}

		return $ret;
	}

	/** Vytvori seznam udalosti podle uzivatele
	 */
	function list_create($user_id) {
		if(!is_numeric($user_id))
			return;
		$query = "SELECT `id`, `symbol`, `description` AS `desc`,\n"
			."	`begin`, `end`, `is_free`,\n"
			."	`reptype`, `repvar1`, `repvar2`\n"
			."FROM `T_FreeBusy`\n"
			."WHERE `user_id` = '".$user_id."'\n"
			."ORDER BY `begin`";
		$this->list_result = $this->db->query($query);
		return $this->db->num_rows($this->list_result);
	}
	
	/** Ziska radek seznamu udalosti podle uzivatele
	 */
	function list_next() {
		if (!isset($this->list_result))
			return null;
		if (!($ret = $this->db->fetch($this->list_result))) {
			$this->db->free($this->list_result);
			unset($this->list_result);
		}
		return $ret;
	}

	/** Vrati data o udalosti
	 */
	function get_event($id, $user_id) {
		if(!is_numeric($id) || !is_numeric($user_id))
			return;
		$query = "SELECT `id`, `symbol`, `description` AS `desc`,\n"
			."	`begin`, `end`, `is_free`,\n"
			."	`reptype`, `repvar1`, `repvar2`\n"
			."FROM `T_FreeBusy`\n"
			."WHERE `id` = '".$id."' "
			."	AND `user_id` = '".$user_id."'\n"
			."LIMIT 1";
		$result = $this->db->query($query);
		$ret = $this->db->fetch($result);
		$this->db->free($result);
		return $ret;
	}

	/** Odstrani udalost podle id a user_id
	 * vraci 0 = nic; 1 = smazano
	 */
	function del_event($id, $user_id) {
		if(!is_numeric($id) || !is_numeric($user_id))
			return;
		$query = "DELETE FROM `T_FreeBusy` "
			."WHERE `id` = '".$id."' "
			.	"AND `user_id` = '".$user_id."' "
				."LIMIT 1";
		$this->db->query($query);
		return $this->db->affected_rows($this->db);
	}

	/** Vlozi udalost
	 * vraci jeji id
	 */
	function add_event($begin, $end, $is_free, $symbol, $desc, $user_id, $reptype, $repvar1, $repvar2) {
		$query = "INSERT INTO `T_FreeBusy` "
			."(`begin`, `end`, `is_free`, `symbol`, `description`, `user_id`,\n"
			."	`reptype`, `repvar1`, `repvar2`)\n"
			."VALUES (\n"
			."	'".addslashes($begin)."', '".addslashes($end)."', '".addslashes($is_free)."',\n"
			."	'".addslashes($symbol)."', '".addslashes($desc)."',\n"
			."	'".addslashes($user_id)."', "
			."	'".addslashes($reptype)."', '".addslashes($repvar1)."', '".addslashes($repvar2)."'\n"
			.")";
		$this->db->query($query);
		return $this->db->last_id($this->db);
	}
}

?>
