<?
function get_day_of_week($day, $month, $year) {
	$en2num = array(
		"Sun" => 6,
		"Mon" => 0,
		"Tue" => 1,
		"Wed" => 2,
		"Thu" => 3,
		"Fri" => 4,
		"Sat" => 5,
	);

	return $en2num[date("D",mktime(0, 0, 0, $month, $day, $year))];
}

function get_month_by_number($month) {
	$month_name = array("Leden", "Únor", "Březen", "Duben", "Květen",
		"Červen", "Červenec", "Srpen", "Září", "Říjen", "Listopad",
		"Prosinec");
	return $month_name[$month - 1];
}

function print_calendar($start_timestamp, $busy = array( "" )) {

	/* tato funkce vykresli kalendar.
	 * prametr $busy je seznam titulku a je pro nej urcena funkce
	 * aktuality_get_month (/engine/lib/aktuality.inc).
	 */

	$days_in_month = date("t", $start_timestamp) + 0;
	$datum = getdate($start_timestamp);
	$today = getdate(time());

	/* zacatek tabulky */
	echo "<div class=kalendar>\n";
	echo "<table class=\"kalendar\" summary=\"Malý měsíční kalendář s vyznačenými akcemi.\">\n";
	echo "<tr><th colspan=\"5\">".get_month_by_number($datum["mon"])
		."</th>";
	echo "<th colspan=\"2\">".$datum["year"]."</th>";
	echo "<tr><th>Po</th><th>Út</th><th>St</th>";
	echo "<th>Čt</th><th>Pá</th><th>So</th><th>Ne</th>";

	/* vyplneni zacatku prvniho radku */
	echo "<tr>";
	for ($col = 0; $col < get_day_of_week(1, $datum["mon"], $datum["year"]);
		$col++)
	{
		echo "<td>&nbsp;</td>";
	}

	/* dny v mesici */
	for ($day = 1; $day <= $days_in_month; $day++) {
	
		echo "<td class=\"num".(($busy[$day] != "")?"busy":"")."\"".
			" title=\"".str_replace('"', '&quot;', $busy[$day])."\"".
			(($today["mday"] == $day && $today["mon"] == $datum["mon"]
			&& $today["year"] == $datum["year"])
				? " id=\"today\"><em>" 
				: ">").
			$day.
			(($today["mday"] == $day && $today["mon"] == $datum["mon"]
			&& $today["year"] == $datum["year"])
				? "</em></td>" 
				: "</td>");

		if (get_day_of_week($day, $datum["mon"], $datum["year"]) == 6
			&& $day < $days_in_month)
		{
			echo "<tr>";
		}
	}

	/* zakonceni posledniho radku */
	for ($col = get_day_of_week($days_in_month, $datum["mon"], $datum["year"]);
		$col < 6; $col++)
	{
		echo "<td>&nbsp;</td>";
	}
	
	
	echo "</table>\n";
	echo "</div>\n";
	
}
?>
