<?
/*****************************************************************************
	
	Josef Kufner <jkufner@seznam.cz>

	Šablona webu -- třída Page

*****************************************************************************/

require_once "config.php";
require_once "alog.php";

class Page {
	var $title = "(undf)";
	var $username = "(undf)";
	var $userlevel = "";
	var $file_script = "";
	var $script = "";
	var $style = "default";
	var $style_dir = "styles/";
	var $style_main = "/main.css";

	function Page($title, $username = "", $level = 0) {
		$this->title = $title;
		$this->username = $username;
		$this->userlevel = $level;
		alog_write($username);
	}

	function set_script($file, $script) {
		$this->file_script = $file;
		$this->script = $script;
	}

	function build_style_filename ($style = null) {
		if ($style == null)
			$style = $this->style;
		return $this->style_dir.$style.$this->style_main;
	}

	function set_style($style) {
		if (is_file($this->build_style_filename($style)))
			$this->style = $style;
	}

	function generate_header() {
		global $SERVER_NAME;
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n";
		echo "			\"http://www.w3.org/TR/html4/loose.dtd\">\n";
		echo "<html>\n";
		echo "<head>\n";
		echo "<title>".$this->title." - Atlantis Planner</title>\n";
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
		echo "<link rel=\"stylesheet\" href=\"".$this->build_style_filename()."\" type=\"text/css\" "
				."title=\"Standart Style Sheet\">\n";
		echo "<link rel=\"alternate\" title=\"".ORG_NAME." - Aktuality\" "
				."href=\"http://atlantis-to.org/planner/aktuality.rss.php\" "
				."type=\"application/rss+xml\">\n";
		echo "<link rel=\"alternate\" title=\"".ORG_NAME." - Forum\" "
				."href=\"http://atlantis-to.org/planner/forum.rss.php\" type=\"application/rss+xml\">\n";
		if ($this->file_script != "") {
			echo "<script type=\"text/javascript\">";
			include($this->file_script);
			echo "</script>";
		}
		echo "\n";
		echo "</head>\n\n";
		
		echo "<body".($this->script != "" ? " onload=\"".$this->script."\"" : "").">\n";
		echo "<div class=header>";
		echo "<h2 class=main>".($this->username == ""
				? "<em>nepřihlášen</em>":$this->username)."</h2>\n";
		echo "<h1 class=main>".$this->title."</h1>\n";
		echo "<hr>\n";

		/* navigace */
		echo "<ul class=nav>\n";
		if ($this->username && $this->userlevel >= 0) {
			echo "<li><a href=\"aktuality.php\">Aktuality</a>\n";
			echo "<li><a href=\"kalendar.php\">Kalendář</a>\n";
			echo "<li><a href=\"freebusy.php\">Free/Busy</a>\n";
			echo "<li><a href=\"topic.php\">Diskuzní&nbsp;fórum</a>\n";
			echo "<li><a href=\"adresar.php\">Adresář</a>\n";
			echo "<li><a href=\"user.php\">Uživatel</a>\n";
			if ($this->userlevel >= 4) {
				echo "<li><a href=\"admin.php\">Admin</a>\n";
			}
			echo "<li><a href=\"logout.php\">Odhlásit&nbsp;se</a>\n";
		} else {
			echo "<li><a href=\"login.php\"><b>Přihlásit&nbsp;se</b></a>\n";
			echo "<li><a href=\"aktuality.php\">Aktuality</a>\n";
			echo "<li><a href=\"kalendar.php\">Kalendář</a>\n";
			echo MENU_NO_LOGIN;
		}
		echo "</ul>\n";
		
		echo "<hr>\n";
		echo "\n</div>\n\n";

		/* body */
		echo "<div class=\"body\">\n";
	}

	function generate_footer() {
		echo "</div>\n\n";
		echo "<div class=\"footer\">\n";
		echo "<hr>\n";
		echo "<span><a href=\"licence.php\">licence &amp; autoři</a>\n";
		echo " &nbsp;|&nbsp; ";
		echo "<a href=\"http://jk.myserver.cz/programy/atlantis_planner\">"
				."stránka aplikace</a>\n";
		echo " &nbsp;|&nbsp; ";
		echo "<a href=\"http://jk.myserver.cz/wiki/Atlantis_Planner\">"
				."dokumentce</a>\n";
		echo " &nbsp;|&nbsp; ";
		echo "<a href=\"mailto:".MAIN_ADMIN_MAIL."?subject=[atlantis-planner]%20\">"
				."správce</a></span>\n";
		echo "<a href=\"http://validator.w3.org/check?uri=referer\">Valid HTML 4.01</a>\n";
		echo " &nbsp;|&nbsp; ";
		echo "<a href=\"http://jigsaw.w3.org/css-validator/check/referer\">Valid CSS</a>\n";
		echo EXTRA_LINK."\n";
		echo "</div>\n";
		echo "</body>\n</html>\n";
	}
}

// vim:ts=4:sw=4:
?>
