<?

class Table {
	var $header = array();
	var $footer = array();
	var $col_width = array();
	var $width = array();
	var $data = array();
	var $col = array();
	var $group_by = null;

	function Table($data, $group_by = null, $width = '100%') {
		$this->data = $data;
		$this->width = $width;
		$this->group_by = $group_by;
	}

	function add_header($title, $width = null) {
		$i = count($this->header);
		$this->header[$i] = $title;
		if ($width != null) {
			$this->col_width[$i] = $width;
		}
	}
	
	function add_footer($title) {
		$i = count($this->footer);
		$this->footer[$i] = $title;
	}

	function add_column($key) {
		$i = count($this->col);
		$this->col[$i] = $key;
	}

	function remove_col($col) {
		unset($this->header[$col]);
		unset($this->footer[$col]);
		unset($this->col[$col]);
		unset($this->col_width[$col]);
	}

	function define_all($def) {
		if (isset($def['head']))
			$this->header = $def['head'];
		if (isset($def['foot']))
			$this->footer = $def['foot'];
		if (isset($def['cols']))
			$this->col = $def['cols'];
		if (isset($def['col_width']))
			$this->col_width = $def['col_width'];
		if (isset($def['group_by']))
			$this->group_by = $def['group_by'];
	}

	function render() {
		$i = 0;
		echo "<table class='OnlyCols' width='".$this->width."'>\n";
		if (count($this->col_width) > 0) {
			echo "\t<colgroup>\n";
			foreach($this->col_width as $c => $w) {
				echo "\t\t<col".($w ? " width='".$w."'":"").">\n";
			}
			echo "\t</colgroup>\n";
		}
		if (count($this->header) > 0) {
			echo "\t<thead>\n\t\t<tr>\n";
			foreach($this->header as $title) {
				echo "\t\t\t<th>".$title."</th>\n";
			}
			echo "\t</thead>\n";
		}
		if (count($this->footer) > 0) {
			echo "\t<tfoot>\n\t\t<tr>\n";
			foreach($this->footer as $title) {
				echo "\t\t\t<th>".$title."</th>\n";
			}
			echo "\t</tfoot>\n";
		}

		echo "\t<tbody>\n";
		$last = null;
		foreach($this->data as $line) {
			if ($this->group_by) {
				if ($last != $line[$this->group_by]) {
					echo "\t\t<tr><th colspan=".count($this->header).">"
						.$line[$this->group_by]."</th>\n";
					$last = $line[$this->group_by];
				}
			}
			echo "\t\t<tr>\n";
			if (count($this->col)) {
				foreach($this->col as $key) {
					echo "\t\t\t<td>".$line[$key]."</td>\n";
				}
			} else {
				foreach($line as $cell) {
					echo "\t\t\t<td>$cell</td>\n";
				}
			}
			$i++;
		}
		echo "\t</tbody>\n";
		echo "</table>\n";
	}
};

?>
