<? // vim:encoding=utf8:
require_once "lib/database.inc.php";
require_once "lib/utils.inc.php";
require_once "lib/user.inc.php";

class Topic {
	var $db;
	var $usr;

	function Topic() {
		$this->db = new Database();
		$this->usr = new User();
	}

	function get_listing($user_id) {
		$user_id = to_num($user_id);
		$r = $this->db->query(
			 "SELECT T_Topic.id as id, T_Topic.name as name,\n"
			."	T_User.name as author, T_User.id as user_id,\n"
			."	T_Topic.date as date, YEAR(T_Topic.date) as `year`,\n"
			."	COUNT(T_Forum.id) as `count`,\n"
			."	SUM(IF(T_Forum_LastView.date < T_Forum.date, 1, 0)) as `read`"
			."FROM T_Topic\n"
			."LEFT JOIN T_User ON T_User.id = T_Topic.user_id\n"
			."LEFT JOIN T_Forum ON T_Topic.id = T_Forum.object_id\n"
			."LEFT JOIN T_Forum_LastView ON T_Forum_LastView.object_id = T_Topic.id\n"
			."	AND T_Forum_LastView.object_type = 2\n"
			."	AND T_Forum_LastView.user_id = ".$user_id."\n"
			."GROUP BY T_Topic.id\n"
			."ORDER BY date DESC"
		);
		$res = array();
		for ($i = 0; $item = $this->db->fetch($r); $i++) {
			$res[$i] = $item;	
			$res[$i][0] = "<a href='forum.php?id=".$item['id']."&amp;type=2'>".$item['name']."</a>";
			$res[$i][1] = $item['user_id'] > 0 ? $this->usr->makelink($item["user_id"], $item["author"])
					: $item["author"];
			$res[$i][2] = str_replace(' ', '&nbsp;', $item['date']);
			$res[$i][3] = $item['read']."&nbsp;/&nbsp;".$item['count'];
			$res[$i][4] = $item['year'];
		}
		return $res;
	}
	function get_listing_tabledef() {
		return array(
			'head' => array (
				"Téma",
				"Založil(a)",
				"Datum založení",
				"Nepřečtených"
			),
			'cols' => array(0, 1, 2, 3),
			'foot' => array(),
			'col_width' => array('', '20%', '20%', '10%'),
			'group_by' => 4
		);
	}

	function get_by_id ($id) {
		$r = $this->db->query(
			 "SELECT T_Topic.id as id, T_Topic.name as name, T_Topic.description as description,\n"
			."	T_User.name as author, date, can_response\n"
			."FROM T_Topic\n"
			."LEFT JOIN T_User ON T_User.id = T_Topic.user_id\n"
			."WHERE T_Topic.id = ".to_num($id)."\n"
			."LIMIT 1"
		);
		return $this->db->fetch($r);
	}

	function to_string($item) {
		return   "<div class=topic>\n"
			."<h1>".$item['name']."</h1>\n"
			."<table>\n"
			."<tr><th>Založil:</th><td>".$item['author']."</td>\n"
			."<tr><th>Datum:</th><td>".$item['date']."</td>\n"
			.($item['can_response']=="0"? "<tr><td colspan=2><b>Zamčeno.</b></td>\n":"")
			."</table>\n"
			."<div>".($item['description'] != "" ? $item['description'] : "&nbsp;")."</div>\n"
			."</div>";
	}

	function create($name, $user, $description, $date = "") {
		$this->db->query(
			 "INSERT INTO T_Topic (name, user_id, date, description)\n"
			."VALUES ('".addslashes($name)."', '".addslashes($user)."', "
			.($date != "" ? "'".addslashes($date)."'" : 'NOW()').", '".addslashes($description)."')"
		);
		return $this->db->last_id();
	}
	
	function object_show($id) {
		$i = $this->get_by_id($id);
		if ($i) {
			echo $this->to_string($i);
		} else {
			echo "<div class=error>\n<h2>Interní chyba aplikace</h2>\n"
				."<p>Nebylo nalezeno zvolené téma.</p>\n"
				."</div>\n";
		}
	}
}
?>
