<?
require_once "lib/database.inc.php";
require_once "lib/utils.inc.php";

class User {
	var $db;
	var $cols = array(
			'user_id'	=> 'user_id',
			'jmeno'		=> 'Jméno',
			'prijmeni'	=> 'Příjmení',
			'prezdivka'	=> 'Přezdívka',
			'datnar'	=> 'Datum narození',
			'svatek'	=> 'Svátek',
			'mobil'		=> 'Mobil',
			'mail'		=> 'e-mail',
			'jabber'	=> 'Jabber',
			'icq'		=> 'ICQ',
			'web'		=> 'Web',
			'home_url'	=> 'URL Domů',
			'adr_ulice'	=> 'Adresa',
			'adr_mesto'	=> '',
			'adr_psc'	=> '',
			'stav'		=> 'Stav',
			'infomail'	=> 'Posílat informace'
	);
	
	function User() {
		$this->db = new Database();
		

	}

	function get_by_id ($id) {
		$r = $this->db->query(
			 "SELECT user_id, jmeno, prijmeni, prezdivka,\n"
			."	datnar, DAY(datnar) as datnar_d, MONTH(datnar) as datnar_m, YEAR(datnar) as datnar_y,\n"
			."	SUBSTRING(svatek, 6) as svatek,\n"
			."	DAY(svatek) as svatek_d, MONTH(svatek) as svatek_m, YEAR(svatek) as svatek_y,\n"
			."	mobil, mail, jabber, icq, web, home_url,\n"
			."	adr_ulice, adr_mesto, adr_psc,\n"
			."	SUBSTRING(adr_psc, 1, 3) as adr_psc0, SUBSTRING(adr_psc, 5, 2) as adr_psc1,\n"
			."	stav, infomail\n"
			."FROM T_Kontakty\n"
			."WHERE user_id = ".$id."\n"
			."LIMIT 1"
		);
		$d = $this->db->fetch($r);
		$this->db->free($r);
		return $d;
	}
	
	function get_all () {
		$r = $this->db->query(
			 "SELECT user_id, jmeno, prijmeni, prezdivka,\n"
			."	datnar, DAY(datnar) as datnar_d, MONTH(datnar) as datnar_m, YEAR(datnar) as datnar_y,\n"
			."	svatek, DAY(svatek) as svatek_d, MONTH(svatek) as svatek_m, YEAR(svatek) as svatek_y,\n"
			."	mobil, mail, jabber, icq, web, home_url,\n"
			."	adr_ulice, adr_mesto, adr_psc,\n"
			."	SUBSTRING(adr_psc, 1, 3) as adr_psc0, SUBSTRING(adr_psc, 5, 2) as adr_psc1,\n"
			."	stav, infomail,\n"
			."	T_User.name AS login\n"
			."FROM T_Kontakty\n"
			."LEFT JOIN `T_User` ON `T_User`.`id` = `T_Kontakty`.`user_id`\n"
			."ORDER BY prijmeni, jmeno"
		);
		
		$i = 0;
		$d = array();
		while ($n = $this->db->fetch($r))
			$d[$i++] = $n;
		$this->db->free($r);
		return $d;
	}

	function change($data) {

		$this->db->query(
			 "DELETE FROM T_Kontakty\n"
			."WHERE user_id = '".$data['user_id']."'\n"
			."LIMIT 1"
		);
		
		if (!$data['datnar'] && $data['datnar_d'] && $data['datnar_m'] && $data['datnar_y']) {
			$data['datnar'] = $data['datnar_y'].'-'.$data['datnar_m'].'-'.$data['datnar_d'];
		}
		if (!$data['svatek'] && $data['svatek_d'] && $data['svatek_m']) {
			$data['svatek'] = '1970-'.$data['svatek_m'].'-'.$data['svatek_d'];
		}
		if (!$data['adr_psc'] && $data['adr_psc0'] && $data['adr_psc1']) {
			$data['adr_psc'] = $data['adr_psc0'].' '.$data['adr_psc1'];
		}

		$first = true;
		$qc = '';
		$qv = '';
		foreach ($this->cols as $k => $v) {
			if (isset($data[$k])) {
				$qc .= ($first?"\t":",\n\t")."`$k`";
				$qv .= ($first?"\t":",\n\t")."'".addslashes($data[$k])."'";
				$first = false;
			}
		}
		$this->db->query(
			 "INSERT INTO T_Kontakty\n"
			."(\n$qc\n)\n"
			."VALUES (\n$qv\n)"
		);
		if ($this->db->affected_rows()) {
			echo "<div class=success><h2>Změny byly uloženy</h2></div>\n";
		} else {
			echo "<div class=error><h2>Záznamy se nepovedlo uložit!</h2></div>\n";
		}
	}

	function makelink($id, $name) {
		return "<a href='user.php?id=$id'>$name</a>";
	}

	function object_show($id) {
		$d = $this->get_by_id($id);
		//echo "<small>Tohle je jen provizorní zobrazení, zanedlouho z téhle obludy udělám něco hezčího.</small>\n";
		echo "<h1>".$d['jmeno']." ".$d['prijmeni']."</h1>\n";
		echo "<table class=\"Vizitka\">\n";
		
		$str = array(); $i = 0; $c = 0;
		foreach( $this->cols as $k => $v) {
			if ($k != 'user_id' && $k != 'infomail' && $k != 'stav') {
				if (empty($str[$i]) && $i != 5) {
					$str[$i] = "<tr>\n";
				}
				$str[$i] .= "\t<th>"
					.($v != '' ? $v.':':'&nbsp;')."</th>";
					
				if (($k == 'web' || $k == 'home_url') && !empty($d[$k]))
					$str[$i] .= "<td width=\"50%\"><a href=\"".$d[$k]."\">"
						.$d[$k]."</a></td>\n";
				elseif ($k == 'mail' && !empty($d[$k]))
					$str[$i] .= "<td width=\"50%\"><a href=\"mailto:".$d[$k]."\">"
						.$d[$k]."</a></td>\n";
				else
					$str[$i] .= "<td width=\"50%\">".$d[$k]."</td>\n";
				$i++;
				if ($c == 0 && $i == 5) {
					$i = 0;
					$c++;
				}
			}
			elseif ($k == 'stav') {
				$str[5] = "<tr>\n\t<th rowspan=4>".($v != '' ? $v.':':'&nbsp;')."</th>\n"
					."<td rowspan=4>".$d[$k]."</td>\n".$str[5];
			}
		}
		echo join($str)."</table>\n";
	}
}
?>
