-- MySQL dump 10.10
--
-- Host: localhost    Database: atlantis
-- ------------------------------------------------------
-- Server version	5.0.7-beta

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `T_ALog`
--

DROP TABLE IF EXISTS `T_ALog`;
CREATE TABLE `T_ALog` (
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `IDUser` int(11) default NULL COMMENT 'vazba na T_User (uživatelovo ID)',
  `IDURLfile` int(11) default NULL COMMENT 'vazba na tabulku T_URL',
  `IDIP` int(11) default NULL COMMENT 'vazba na tabuli s IP adresama',
  `IDBrowser` int(11) default NULL COMMENT 'vazba na T_Browser (uživatelův prohlížeč)',
  `IDURLreferer` int(11) default NULL COMMENT 'vazba na T_URL',
  KEY `IDUser` (`IDUser`)
);

--
-- Table structure for table `T_ALog_Browser`
--

DROP TABLE IF EXISTS `T_ALog_Browser`;
CREATE TABLE `T_ALog_Browser` (
  `IDBrowser` int(11) NOT NULL auto_increment,
  `IdentString` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`IDBrowser`),
  UNIQUE KEY `IdentString` (`IdentString`)
);

--
-- Table structure for table `T_ALog_IP`
--

DROP TABLE IF EXISTS `T_ALog_IP`;
CREATE TABLE `T_ALog_IP` (
  `IDIP` int(11) NOT NULL auto_increment,
  `IP` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`IDIP`),
  UNIQUE KEY `IP` (`IP`)
);

--
-- Table structure for table `T_ALog_URL`
--

DROP TABLE IF EXISTS `T_ALog_URL`;
CREATE TABLE `T_ALog_URL` (
  `IDURL` int(11) NOT NULL auto_increment,
  `URL` text NOT NULL,
  PRIMARY KEY  (`IDURL`)
);

--
-- Table structure for table `T_Aktuality`
--

DROP TABLE IF EXISTS `T_Aktuality`;
CREATE TABLE `T_Aktuality` (
  `id` int(11) NOT NULL auto_increment,
  `type` int(11) NOT NULL default '0',
  `IDUser` int(11) default NULL COMMENT 'vazba na zadávající/editujícího uživatele T_User',
  `modified` datetime NOT NULL default '1970-01-01 00:00:00',
  `date_start` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_end` datetime NOT NULL default '0000-00-00 00:00:00',
  `fdate` tinytext,
  `title` tinytext NOT NULL,
  `text` text NOT NULL,
  `sraz` text,
  `ssebou` text,
  `cena` text,
  `ps` text,
  `image` varchar(16) default NULL,
  `urlonimage` varchar(1024) default NULL COMMENT 'URL na krerou odkazuje obrazek',
  `is_sent` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `IDUser` (`IDUser`),
  KEY `idx_complex` (`type`,`date_start`,`modified`,`is_sent`)
);

--
-- Table structure for table `T_Auth`
--

DROP TABLE IF EXISTS `T_Auth`;
CREATE TABLE `T_Auth` (
  `user_id` int(11) NOT NULL default '0',
  `auth` varchar(32) NOT NULL default '0',
  `time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`user_id`)
);

--
-- Table structure for table `T_Editor_Post`
--

DROP TABLE IF EXISTS `T_Editor_Post`;
CREATE TABLE `T_Editor_Post` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL,
  `user_id` int(11) NOT NULL default '0',
  `form_number` int(11) NOT NULL default '0',
  `hash` char(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `is_complete` (`user_id`,`form_number`,`hash`)
);

--
-- Table structure for table `T_Forum`
--

DROP TABLE IF EXISTS `T_Forum`;
CREATE TABLE `T_Forum` (
  `id` int(11) NOT NULL auto_increment,
  `object_id` int(11) NOT NULL default '0',
  `object_type` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  `pos_left` int(11) NOT NULL default '0',
  `pos_right` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `can_response` tinyint(1) NOT NULL default '1',
  `author` text NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `email` text,
  `www` text,
  `title` text NOT NULL,
  `text` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_complex` (`parent`,`user_id`,`date`)
);

--
-- Table structure for table `T_Forum_LastView`
--

DROP TABLE IF EXISTS `T_Forum_LastView`;
CREATE TABLE `T_Forum_LastView` (
  `user_id` int(11) NOT NULL default '0',
  `object_id` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `object_type` int(11) NOT NULL default '0'
);

--
-- Table structure for table `T_FreeBusy`
--

DROP TABLE IF EXISTS `T_FreeBusy`;
CREATE TABLE `T_FreeBusy` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `begin` date NOT NULL default '0000-00-00',
  `end` date default '0000-00-00',
  `symbol` varchar(5) NOT NULL default '',
  `description` varchar(64) NOT NULL default '',
  `is_free` int(1) NOT NULL default '0',
  `reptype` int(4) NOT NULL default '0',
  `repvar1` int(8) default '0',
  `repvar2` int(8) default '0',
  PRIMARY KEY  (`id`),
  KEY `idx_complex` (`user_id`,`begin`,`end`,`is_free`)
);

--
-- Table structure for table `T_Kontakty`
--

DROP TABLE IF EXISTS `T_Kontakty`;
CREATE TABLE `T_Kontakty` (
  `user_id` int(11) NOT NULL default '0',
  `jmeno` varchar(30) NOT NULL default '',
  `prezdivka` varchar(30) default NULL,
  `prijmeni` varchar(30) NOT NULL default '',
  `datnar` date default NULL,
  `svatek` date default NULL,
  `mobil` varchar(30) default NULL,
  `mail` varchar(100) default NULL,
  `jabber` varchar(100) default NULL,
  `icq` varchar(30) default NULL,
  `web` varchar(100) default NULL,
  `home_url` varchar(50) default NULL,
  `adr_ulice` varchar(50) default NULL,
  `adr_mesto` varchar(50) default NULL,
  `adr_psc` varchar(6) default NULL,
  `stav` varchar(40) default NULL,
  `infomail` int(1) NOT NULL default '1',
  PRIMARY KEY  (`user_id`)
);

--
-- Table structure for table `T_Object_Type`
--

DROP TABLE IF EXISTS `T_Object_Type`;
CREATE TABLE `T_Object_Type` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `class` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`id`)
);

--
-- Table structure for table `T_Topic`
--

DROP TABLE IF EXISTS `T_Topic`;
CREATE TABLE `T_Topic` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `can_response` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

--
-- Table structure for table `T_Ucast`
--

DROP TABLE IF EXISTS `T_Ucast`;
CREATE TABLE `T_Ucast` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `aktuality_id` int(11) NOT NULL default '0',
  `state` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

--
-- Table structure for table `T_User`
--

DROP TABLE IF EXISTS `T_User`;
CREATE TABLE `T_User` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `perm_level` int(8) NOT NULL default '1',
  `passwd` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
);

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

