<?
require_once "lib/auth.inc.php";
require_once "lib/page.inc.php";
require_once "lib/user.inc.php";
require_once "lib/table.inc.php";

function build_list ($enabled, $title) {
	global $auth;

	$logins = $auth->get_accounts(false, ! $enabled);
	if (count($logins) > 0) {
		$usr = new User();

		echo "<h2>".$title."</h2>";

		foreach ($logins as $k => $v) {
			$logins[$k]['name'] = $usr->makelink($v['id'], $v['name']);
			$logins[$k]['perm_change'] = '<a href="user-perm.php?id='.$v['id'].'">oprávnění</a>';
		}

		$t = new Table($logins);
		$t->add_column('name');
		$t->add_header('Login', '40%');
		$t->add_column('id');
		$t->add_header('ID', '20%');
		$t->add_column('perm_level');
		$t->add_header('Úroveň oprávnění', '20%');
		$t->add_column('perm_change');
		$t->add_header('Změnit', '20%');
		$t->render();
	}
}

/*** page init **************************************************************/
$auth = new Auth();
$lvl = $auth->check_login();

$page = new Page("Správa uživatelských účtů", $auth->get_username(), $lvl);
$page->generate_header();

if ($lvl < AUTH_ADMIN) {
	$auth->print_must_login();
	$page->generate_footer();
	exit;
}


build_list(true, "Povolené účty");
build_list(false, "Zakázané účty");


/*** page cleanup ***********************************************************/
$page->generate_footer();

?>
