<?
require_once "lib/auth.inc.php";
require_once "lib/page.inc.php";
require_once "lib/user.inc.php";
require_once "lib/editor.inc.php";

/*** page init **************************************************************/
$auth = new Auth();
$lvl = $auth->check_login();
$page = new Page("Změna přístupových práv", $auth->get_username(), $lvl);
$page->generate_header();
if ($lvl == 0) {
	$auth->print_must_login();
	$page->generate_footer();
	exit;
}
if ($lvl < AUTH_ADMIN) {
	$auth->print_access_denied();
	$page->generate_footer();
	exit;
}
$usr = new User();

/*** stranka ****************************************************************/

if (isset($_GET['id']) && !isset($_POST['id'])) {
	$id = intval($_GET['id']);
} elseif (isset($_POST['id'])) {
	$id = intval($_POST['id']);
} else {
	$id = 0;
}


$ed_auth = new Auth();
$ed_auth->load($id);

if ($id) {
	$u = $usr->get_by_id($id);
} else {
	echo "<div class='error'>Chybí id uživatele.</div>";
	$page->generate_footer();
	exit;
}

$ed = new Editor($_POST, array('id'=>$id, 'new_permlevel' => $ed_auth->get_permlevel()), $ed_auth->get_userid(), 53);
$ed->add_hidden('id', 0);
$ed->add_label($ed_auth->get_username().': '.$u['jmeno']." ".$u['prijmeni']." (".$u['prezdivka'].")");
$ed->add_combo('new_permlevel', 'Úrověn práv', $ed_auth->get_levelnames(), true);

if ($ed->is_completed()) {
	$val = $ed->get_values();
	$links = "<p><a href=\"user-list.php\">Správa uživatelských účtů</p>\n"
		."<p><a href=\"user.php?id=".$val['id']."\">Zobrazit uživatele</p>\n";
	if ($auth->change_permlevel($val['id'], $val['new_permlevel'])) {
		echo "<div class=success><h2>Úroveň oprávňení byla změněna</h2>".$links."</div>\n";
	} else {
		echo "<div class=error><h2>Úroveň oprávňení se nepovedlo změnit!</h2>".$links."</div>\n";
	}
} else {
	$ed->render_form();
}

/*** page cleanup ***********************************************************/
$page->generate_footer();

?>
